function [inFILE fNAME VAL] = GUI_MeshFile(inFILE,fNAME,VAL)
%-------------------------------------------------------------------------%
% Function to read in mesh properties in GUI
%-------------------------------------------------------------------------%
%
% Programming by Arnkjell Loekke
% UCB / NTNU 2013
% email: lokke@stud.ntnu.no
%
%-------------------------------------------------------------------------%
%

% Initialize figure
f2.h = figure('Visible','off','MenuBar','none','numbertitle','off','Toolbar','none','Position',[50,300,310,200]);

% UI controls
Opt.h = uipanel('Parent',f2.h,'Units','pixels','Position',[10,10,290,175]);
h2.inFILEcb = uicontrol(Opt.h,'Style','checkbox','String','Use own mesh input file? (input file name below)','Value',inFILE,'Units','pixels','Position',[12,140,270,20],'Callback',{@inFILEcb_Callback});
h2.fNAMEed = uicontrol(Opt.h,'Style','edit','String',fNAME,'Units','pixels','Position',[12,110,260,20],'Callback',{@fNAMEed_Callback});
h2.VALed = uicontrol(Opt.h,'Style','edit','String',num2str(VAL,'%5.0f%5.0f%5.0f%10.3f%10.3f%5.0f'),'Units','pixels','Position',[12,40,260,20],'Callback',{@VALed_Callback});
h2.VALst = uicontrol(Opt.h,'Style','text','String','Input the following variables, separated by space:','Units','pixels','Position',[12,80,252,20]);
h2.VAL2st = uicontrol(Opt.h,'Style','text','String','NUMNP  NUMEL  NBASE  Spacing  WL  NPP','Units','pixels','Position',[12,60,260,20]);
h2.DONEpb = uicontrol(Opt.h,'Style','pushbutton','String','Done','Units','pixels','Position',[160,5,112,25],'Callback',{@DONEpb_Callback});

% Initialize the GUI
% Change units to normalized so components resize automatically.
set([f2.h,Opt.h,h2.inFILEcb,h2.fNAMEed,h2.VALed,h2.VALst,h2.VAL2st,h2.DONEpb],'Units','normalized');
% Assign a GUI name to appear in the window title.
set(f2.h,'Name','Mesh Input File')
% Move the GUI to the center of the screen.
movegui(f2.h,'center')
% Make the GUI visible.
set(f2.h,'Visible','on');   

% CALLBACKS

% inFILE callback
function inFILEcb_Callback(hObject,eventdata)
    inFILE = get(hObject,'Value');
end
% fNAME Callback
function fNAMEed_Callback(hObject, eventdata, handles)
    fNAME = get(hObject,'string');
    if exist(fNAME,'file') ~= 2; errordlg('File does not exist','Bad Input','modal'); inFILE =0; else inFILE=1; end
    set(h2.inFILEcb,'Value',inFILE);
end
% VAL Callback
function VALed_Callback(hObject, eventdata, handles)
    VAL = get(hObject,'string');
    VAL = str2num(VAL);
end
% Save and return callback
function DONEpb_Callback(hObject, eventdata, handles)
    if inFILE==1 && exist(fNAME,'file') ~= 2; errordlg('File does not exist','Bad Input','modal'); inFILE =0; uiwait; end
    close
end

% Wait until user has selected option before continuing
uiwait;

end