function Plot_Disp(DOF,Post,ft)
%-------------------------------------------------------------------------%
% Function to plot displacements for DOF in current figure
%-------------------------------------------------------------------------%
%
% Programming by Arnkjell Loekke
% UCB / NTNU 2013
% email: lokke@stud.ntnu.no
%
%-------------------------------------------------------------------------%

Disp=Post.Displacement.U(DOF,:)*ft;
Time=Post.Displacement.t;

[maxd maxdpos]= max(abs(Disp)); maxdsign = sign(Disp(maxdpos));
plot(Time,Disp,'k'); hold on
plot(Time(maxdpos),maxd*maxdsign,'ok')
plot([0 Time(end)], [0 0],'k','linewidth',0.5)
text(Time(maxdpos)+.4,maxd*maxdsign*1.05,num2str(maxd,'%5.2f'))
if any(Disp); axis([0 max(Time) [-1.1 1.1]*max(abs(Disp))]); end