function gcf=Plot_Mesh(NUMEL,COORD,Element,unitSI)
%-------------------------------------------------------------------------%
% Function to plot mesh
%-------------------------------------------------------------------------%
%
% Programming by Arnkjell Loekke
% UCB / NTNU 2013
% email: lokke@stud.ntnu.no
%
%-------------------------------------------------------------------------%

% Check units
ft2m=0.3048; unitTick='(in m)';
if unitSI==0; 
    ft2m=1;
    unitTick='(in ft)';
end

gcf=figure;
hold on
for i=1:NUMEL
    co=COORD(Element(i,:),:);
    l1x=[co(1,1) co(2,1)]*ft2m; l1y=[co(1,2) co(2,2)]*ft2m;
    l2x=[co(2,1) co(3,1)]*ft2m; l2y=[co(2,2) co(3,2)]*ft2m;
    l3x=[co(3,1) co(4,1)]*ft2m; l3y=[co(3,2) co(4,2)]*ft2m;
    l4x=[co(4,1) co(1,1)]*ft2m; l4y=[co(4,2) co(1,2)]*ft2m;
    plot(l1x,l1y,'k'); plot(l2x,l2y,'k');
    plot(l3x,l3y,'k'); plot(l4x,l4y,'k');
end

% Plot drawing
title('Element meshing of dam section');
xlabel(['Distance from dam heel ',unitTick]);
ylabel(['Height above dam base ',unitTick]);
axis([[-.1 1.1]*max(COORD(:,1)) [0 1.1]*max(COORD(:,2))]*ft2m)
axis equal; box on

