c                                                                       eag00010
c***********************************************************************eag00020
c                                                                      *eag00030
c     program identification - eagd-84                                 *eag00040
c     program description    - earthquake analysis of gravity dam -    *eag00050
c                              foundation rock - water systems         *eag00060
c     programmed by          - p. chakrabarti                          *eag00070
c     modifications by       - sunil gupta, gautam dasgupta,           *eag00080
c                              gregory fenves                          *eag00090
c                              university of california, berkeley      *eag00100
c                                                                      *eag00110
c***********************************************************************eag00120
c                                                                       eag00130
C ***** NOTICE TO USERS OF THIS SOFTWARE *****						  eagd84.a
C																	  eagd84.b
C	 COPYRIGHT (C) 1984												  eagd84.c
C	 THE REGENTS OF THE UNIVERSITY OF CALIFORNIA (REGENTS)			  eagd84.d
C	 ALL RIGHTS RESERVED											  eagd84.e
C																	  eagd84.f
C  IN NO EVENT SHALL REGENTS OF THE UNIVERSITY OF CALIFORNIA BE		  eagd84.g
C  LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL,     eagd84.h
C  OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF	  eagd84.i
C  THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IT REGENTS	  eagd84.j
C  HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.				  eagd84.k
C 																	  eagd84.l
C  REGENTS SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT	  eagd84.m
C  NOT LIMITED TO, THE IMPLIED WARRANTIES OR MERCHANTABILITY AND	  eagd84.n
C  FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE AND ACCOMPANYING	  eagd84.o
C  DOCUMENTATION, IF ANY, PROVIDED HEREUNDER IS PROVIDED "AS IS".	  eagd84.p
C  REGENTS HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,		  eagd84.q
C  UPDATES, ENHANCEMENTS, OR MODIFICATIONS.							  eagd84.r
C 																	  eagd84.s
      implicit double precision (a-h,o-z)                               eag00140
c                                                                       eag00150
c     change the following two cards to modify the amount of available  eag00160
c     common storage                                                    eag00170
c                                                                       eag00180
c
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c   Modification 2013: Increased memory storage to allow for large FE
c                      discretizations and increased number of Ritz Vec.
c   OLD:
c     common a(30000)                                                   eag00190
c     mstor =  30000                                                    eag00200
c   NEW:
      common a(9000000)                                                 eag00190
      mstor =  9000000                                                  eag00200
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c	  
      open (1,file='fort.1',form='UNFORMATTED',status='UNKNOWN')
      open (2,file='fort.2',form='UNFORMATTED',status='UNKNOWN')
      open (3,file='fort.3',form='UNFORMATTED',status='UNKNOWN')
      open (5,file='input',form='FORMATTED',status='UNKNOWN')
      open (6,file='output',form='FORMATTED',status='UNKNOWN')
      open (80,file='fort.80',form='FORMATTED',status='UNKNOWN')
      open (90,file='fort.90',form='UNFORMATTED',status='UNKNOWN')
      open (10,file='fort.10',form='FORMATTED',status='UNKNOWN')
      open (15,file='fort.15',form='FORMATTED',status='UNKNOWN')
c     open (7,file='displ',form='FORMATTED',status='UNKNOWN')
      rewind 1
      rewind 2
      rewind 3
      rewind 5
      rewind 6
c     rewind 7
      rewind 10
      rewind 15
      rewind 80
      rewind 90
c                                                                       eag00210
      call eagd1 (a,mstor)                                              eag00220
      stop                                                              eag00230
      end                                                               eag00240
      subroutine eagd1 (a,mstor)                                        eag00250
c                                                                       eag00260
c     ***************************************************************** eag00270
c     control execution and allocate dynamic storage for solution       eag00280
c     phases                                                            eag00290
c     ***************************************************************** eag00300
c                                                                       eag00310
      implicit real*8 (a-h,o-z)                                         eag00320
      common /cntrl1/ numnp,mband,numel,nbc,igrav,npp,wl,trace,iopr,    eag00330
     .                iopp,nbase,irig,xjunk(12)                         eag00340
      common /label/  hed(10)                                           eag00350
      common /cntrl2/ ndata,nwr,dt,nrest,nbuf,nblock,ihv,ncomp,isel,    eag00360
     .                icomb,nprint,nd                                   eag00370
c
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c   Modification 2013: Increased number of allowable damping coefficients
c                      and a0-values
c   OLD:
c     common /afound/ nw,ndamp,a0csb(91),dmp(4)                         eag00380
c   NEW:
      common /afound/ nw,ndamp,a0csb(600),dmp(50)                       eag00380
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
c  
c                                                                       eag00390
      dimension a(1)                                                    eag00400
      data t2,t3,t4,t5,t6/5*0.0d0/,pi/3.14159265358979d0/               eag00410
c                                                                       eag00420
      nbcom = 1                                                         eag00430
      n1 = 1                                                            eag00440
c                                                                       eag00450
c     read and print control information                                eag00460
c                                                                       eag00470
      read  (5,1000) hed,numnp,numel,nummat,nbase,nev,wl,npp,           eag00480
     .               igrav,psp,ires,iopr,iopp,irig,igen                 eag00490
      write (6,2000) hed,numnp,numel,nummat,nbase,nev,wl,npp,           eag00500
     .               igrav,psp,ires,iopr,iopp,irig,igen                 eag00510
c                                                                       eag00520
      if (psp.eq.0.0) write (6,2020)                                    eag00530
      if (psp.ne.0.0) write (6,2021)                                    eag00540
c                                                                       eag00550
      if (irig.eq.0) go to 100                                          eag00570
      nbase=0                                                           eag00580
      write (6,2100)                                                    eag00590
      go to 105                                                         eag00600
c                                                                       eag00610
c     read foundation rock properties                                   eag00620
c                                                                       eag00630
  100 read (5,1050) e,rho,damp,rbase                                    eag00640
      if (igen.eq.0) go to 30                                           eag00650
c                                                                       eag00660
c     generate dynamic stiffness matrix                                 eag00670
c                                                                       eag00680
      rewind 80                                                         eag00690
      read (80,1060) mcode,es,rnu,nj,nw,ndamp,(dmp(i),i=1,ndamp)        eag00700
      read (80,1070) (a0csb(i+1),i=1,nw)                                eag00710
      a0csb(1)=0.0                                                      eag00720
c                                                                       eag00730
	  do 10 i=1,ndamp                                                   eag00740 
      if (damp.eq.dmp(i)) go to 20                                      eag00750
   10 continue                                                          eag00760
      write (6,2005) damp                                               eag00770
      go to 200                                                         eag00780
   20 nrec=6*nw*nj*(i-1)/4                                              eag00790
      nn=nw+1                                                           eag00800
      rewind 90                                                         eag00810
      write (90) mcode,es,rnu,nbase,nn,damp                             eag00820
      write (90) (a0csb(i),i=1,nn)                                      eag00830
c                                                                       eag00840
      nb2=nbase+nbase                                                   eag00850
      nnb=8*nbase*nbase                                                 eag00860
      n2=n1+6*nw*nbase                                                  eag00870
      n3=n2+nnb                                                         eag00880
      n4=n3+nnb                                                         eag00890
      n5=n4+nnb                                                         eag00900
      nimpd=n5+nnb                                                      eag00910
      nbcom=max0(nbcom,nimpd)                                           eag00920
      if (nimpd.gt.mstor) go to 190                                     eag00930
      call imnctr (a(n1),a(n2),a(n3),a(n4),a(n5),nw,nbase,              eag00940
     .             nb2,nj,nrec,rnu)                                     eag00950
c                                                                       eag00960
c     read dynamic stiffness matrix                                     eag00970
c                                                                       eag00980
   30 rewind 90                                                         eag00990
      read (90) mcode,es,rnu,nj,nw,xdamp                                eag01000
      vs=dsqrt(0.5*e/(rho*(1.+rnu)))                                    eag01010
      write (6,2060) hed,e,rnu,rho,damp,rbase,vs                        eag01020
      if (damp.eq.xdamp.and.nbase.eq.nj) go to 40                       eag01030
      write (6,2007)                                                    eag01040
      go to 200                                                         eag01050
   40 read (90) (a0csb(i),i=1,nw)                                       eag01060
      if (psp.eq.0.) es=es*(1.+2.*rnu)/(1.+rnu)**2.                     eag01070
      escale=e/es                                                       eag01080
      dws=vs/rbase                                                      eag01090
      do 50 i=1,nw                                                      eag01100
   50 a0csb(i)=a0csb(i)*dws                                             eag01110
c                                                                       eag01120
c     read data and form element properties                             eag01130
c                                                                       eag01140
  105 neq=2*numnp                                                       eag01160
      num=3*numel                                                       eag01170
      n2=n1+numnp                                                       eag01180
      n3=n2+numnp                                                       eag01190
      n4=n3+neq                                                         eag01200
      n5=n4+numnp                                                       eag01210
      n6=n5+nummat                                                      eag01220
      n7=n6+nummat                                                      eag01230
      nstiff=n7+nummat                                                  eag01240
      nbcom=max0(nbcom,nstiff)                                          eag01250
      if (nstiff.gt.mstor) go to 190                                    eag01260
      call stiff(a(n1),a(n2),a(n3),a(n4),a(n5),a(n6),a(n7),nummat,psp)  eag01270
c                                                                       eag01280
c     form total stiffness and mass matrices                            eag01290
c                                                                       eag01300
      n4=n3+nbc                                                         eag01310
      n5 =n4 +npp                                                       eag01320
      n6 =n5 +neq                                                       eag01330
      nb2=nbase*2                                                       eag01340
      n7=n6+nev                                                         eag01350
      n8=n7+2*nb2*nb2                                                   eag01360
      n9=n8+nb2                                                         eag01370
      n10=n9+(neq*mband)                                                eag01380
      n11=n10+neq                                                       eag01390
      n12=n11+nb2*3                                                     eag01400
      ntotal=n12+nb2*3                                                  eag01410
      nbcom=max0(nbcom,ntotal)                                          eag01420
      if (ntotal.gt.mstor) go to 190                                    eag01430
      call total (a(n1),a(n2),a(n3),a(n4),a(n5),a(n7),a(n8),a(n9),      eag01440
     .            a(n10),a(n11),a(n12),neq,mband,sgn,nb2,escale)        eag01450
c                                                                       eag01460
c     solve for static loads                                            eag01470
c                                                                       eag01480
      if (igrav.eq.0) go to 140                                         eag01490
      n12=n11+numel                                                     eag01500
      n13=n12+numel                                                     eag01510
      n14=n13+numel                                                     eag01520
      n15=n14+numel                                                     eag01530
      n16=n15+num                                                       eag01540
      n17=n16+24*numel                                                  eag01550
      n18=n17+2*numel                                                   eag01560
      nstatc=n18+8*numel                                                eag01570
      nbcom=max0(nbcom,nstatc)                                          eag01580
      if (nstatc.gt.mstor) go to 190                                    eag01590
      call static (a(n3),a(n10),a(n9),a(n11),a(n12),a(n13),a(n14),      eag01600
     .             a(n15),a(n16),a(n17),a(n18),neq,mband,num,numel)     eag01610
c                                                                       eag01620
c     modeshapes and frequencies                                        eag01630
c                                                                       eag01640
  140 if (nev.le.0) go to 200                                           eag01660
      n12=n11+neq                                                       eag01670
      n13=n12+neq                                                       eag01680
      n14=n13+neq                                                       eag01690
      neigen=n14+(nev*nev)                                              eag01700
      nbcom=max0(nbcom,neigen)                                          eag01710
      if (neigen.gt.mstor) go to 190                                    eag01720
      call eigen (a(n3),a(n5),a(n6),a(n7),a(n8),a(n9),a(n10),a(n11),    eag01730
     .            a(n12),a(n13),a(n14),escale,nb2,neq,nev,mband)        eag01740
      if (ires.ne.0) go to 200                                          eag01760
c                                                                       eag01770
c     compute complex-valued frequency response functions for           eag01780
c     generalized coordinates                                           eag01790
c                                                                       eag01800
      read (5,1020) ihv,nexp,dt,alpha,dfac1                             eag01810
      ndata=2**nexp                                                     eag01820
      write (6,2070) hed,ihv,ndata,dt,alpha,dfac1                       eag01830
      if (irig.ne.0) go to 150                                          eag01840
      if (pi/dt.le.a0csb(nw)) go to 150                                 eag01850
      write (6,2071) a0csb(nw)                                          eag01860
      go to 200                                                         eag01870
  150 nev1=nev+1                                                        eag01880
      nwr  =100                                                         eag01890
      ncomp=1                                                           eag01900
      if (ihv.eq.2) ncomp=2                                             eag01910
      ihyd = 1                                                          eag01920
      if (npp.gt.0) ihyd = 0                                            eag01930
      call comntr (a(n2),a(n4),npp,ihyd,dt,wl,nterm)                    eag01940
      if (npp.eq.0) write (6,2095)                                      eag01950
      n10=n9 +(neq*nev)                                                 eag01960
      n11=n10+2*nev*nev                                                 eag01970
      n13=n11+2*nev*nev                                                 eag01980
      n14=n13+2*nb2                                                     eag01990
      n15=n14+2*(nev*ncomp)                                             eag02000
      n16=n15+2*(nev*nev)                                               eag02010
      n17=n16+(nev*nev1)                                                eag02020
      n18=n17+2*(nev*nev)                                               eag02030
      n19=n18+nev                                                       eag02040
      n20=n19+nev*ncomp                                                 eag02050
      n21=n20+2*nterm                                                   eag02060
      n22=n21+2*nterm                                                   eag02070
      n23=n22+2*nev1*nterm                                              eag02080
      n24=n23+2*nev1*nterm                                              eag02090
      n25=n24+2*nterm                                                   eag02100
      n26=n25+2*nev1                                                    eag02110
      n27=n26+2*nev1                                                    eag02120
      nfr=ndata+1                                                       eag02130
      if (nwr.gt.nfr) nwr=nfr                                           eag02140
      nbuf=nwr*nev                                                      eag02150
      nkompx=n27+2*(nbuf*ncomp)                                         eag02160
      nbcom=max0(nbcom,nkompx)                                          eag02170
      if (nkompx.gt.mstor) go to 190                                    eag02180
      call komplx(a(n2),a(n4),a(n5),a(n6),a(n7),a(n8),a(n9),a(n10),     eag02190
     .     a(n11),a(n7),a(n13),a(n14),a(n15),a(n16),a(n17),a(n18),      eag02200
     .     a(n19),a(n20),a(n21),a(n22),a(n23),a(n24),a(n25),a(n26),     eag02210
     .     a(n25),a(n25),a(n27),alpha,dfac1,sgn,nev,nev1,neq,nterm,     eag02220
     .     nbuf,escale,nb2)                                             eag02230
c                                                                       eag02250
c     time responses of modal displacements                             eag02260
c                                                                       eag02270
      read (5,1030) nxugh,nxugv,td                                      eag02280
      nxug=max0(nxugh,nxugv)                                            eag02290
      if (nxug.le.0) go to 200                                          eag02300
      write (6,2080) hed,nxugh,nxugv,td                                 eag02310
      n2=n1+2*(nfr*nev1)                                                eag02320
      n3=n2+2*(ndata)                                                   eag02330
      n4=n3+2*nbuf                                                      eag02340
      n5=n4+nxug                                                        eag02350
      ntrnsm=n5+nxug                                                    eag02360
      nbcom=max0(nbcom,ntrnsm)                                          eag02370
      if (ntrnsm.gt.mstor) go to 190                                    eag02380
      call trnfrm (a(n1),a(n2),a(n3),a(n4),a(n5),nexp,nfr,nev,td,       eag02390
     .             nxugh,nxugv)                                         eag02400
c                                                                       eag02410
c     superposition of modes and evaluation of stresses                 eag02420
c                                                                       eag02430
      read (5,1040) nprint,icomb,isel,nnode,nnelm                       eag02440
      write (6,2090) hed,nprint,icomb,isel,nnode,nnelm                  eag02450
      n2 =n1 +neq                                                       eag02460
      n3 =n2 +neq                                                       eag02470
      n4 =n3 +(neq*nev)                                                 eag02480
      n5 =n4 +nev                                                       eag02490
      n6 =n5 +2*nbuf                                                    eag02500
      n7 =n6 +numel                                                     eag02510
      n8 =n7 +numel                                                     eag02520
      n9 =n8 +numel                                                     eag02530
      n10=n9 +numel                                                     eag02540
      n11=n10+nnode                                                     eag02550
      n12=n11+nnelm                                                     eag02560
      n13=n12+ 3*numel                                                  eag02570
      n14=n13+24*numel                                                  eag02580
      n15=n14+ 2*numel                                                  eag02590
      nrespn=n15+ 8*numel                                               eag02600
      nbcom=max0(nbcom,nrespn)                                          eag02610
      if (nrespn.gt.mstor) go to 190                                    eag02620
      call respns (a(n1),a(n2),a(n3),a(n4),a(n5),a(n6),a(n7),a(n8),     eag02630
     .     a(n9),a(n10),a(n11),a(n12),a(n13),a(n14),a(n15),nnode,nnelm, eag02640
     .     neq,nev,numel,num)                                           eag02650
      go to 200                                                         eag02670
c                                                                       eag02680
  190 write (6,2010)                                                    eag02690
  200 call joblog (mstor,nbcom,t1,t2,t3,t4,t5,t6)                       eag02700
      return                                                            eag02710
c                                                                       eag02720
 1000 format (10a8/5i5,f10.0,2i5, f5.0,6i5)                             eag02730
 1020 format (2i5,3f10.0)                                               eag02740
 1030 format (2i5, f10.0)                                               eag02750
 1040 format (5i5)                                                      eag02760
 1050 format (8f10.3)                                                   eag02770
c
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c   Modification 2013: Increased number of allowable damping coefficients
c    
c   OLD:
c 1060 format (i2,2f10.0,3i5,4f8.0)                                     eag02780
c   NEW:
 1060 format (i2,2f10.0,3i5,99f8.0)                                     eag02780
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
 1070 format (10f7.0)                                                   eag02790
 2000 format (1h1,20x,10a8///,                                          eag02800
     . 1x,19(1h*)/20h control information/1x,19(1h*)//                  eag02810
     . 50h0number of nodal points...........................i4/         eag02820
     . 50h0number of elements...............................i4/         eag02830
     . 50h0number of different materials....................i4/         eag02840
     . 50h0number of base connection nodes at foundation....i4/         eag02850
     . 50h0number of generalized coordinates (eigenvalues)..i4/         eag02860
     . 50h0water level in the reservoir.....................f10.3,3h ft/eag02870
     . 50h0number of upstream nodes touching water..........i4/         eag02880
     . 50h0code for static analysis.........................i4/         eag02890
     . 50h0code for plane stress/strain model...............1x,f5.1/    eag02900
     . 50h0code for dynamic analysis........................i4/         eag02910
     . 50h0code for  reading mode shapes and frequencies....i4/         eag02920
     . 50h0code for punching mode shapes and frequencies....i4/         eag02930
     . 50h0code for including foundation-rock interaction...i4/         eag02940
     . 50h0code for generating dynamic stiffness matrix.....i4/)        eag02950
 2005 format (82h0***** foundation compliance data not available for reqeag02960
     .uested damping coefficient  ,f10.5)                               eag02970
 2007 format (91h0***** properties of  dynamic  stiffness   matrix on taeag02980
     .e90 do not match the specified ones )                             eag02990
 2010 format(////42h ***** blank common storage exceeded *****////)     eag03000
 2020 format (///1x,5(1h*),40h the following is a plane stress problem, eag03010
     .        5(1h*)///)                                                eag03020
 2021 format (///1x,5(1h*),40h the following is a plane strain problem, eag03030
     .        5(1h*)///)                                                eag03040
 2060 format (1h1,                                                      eag03050
     . 20x,10a8//1x,29(1h*)/30h foundation rock specification /1x,      eag03060
     . 29(1h*)///                                                       eag03070
     . 31h youngs modulus              = d12.5,7h k/sft.//              eag03080
     . 31h poissons ratio              = f12.5//                        eag03090
     . 31h mass density                = f12.5,15h k-sec**2/ft**4//     eag03100
     . 31h hysteretic damping factor   = f12.5//                        eag03110
     . 31h base node spacing           = f12.5,4h ft.//                 eag03120
     . 31h shear wave velocity         = f12.5,7h ft/sec//)             eag03130
 2070 format (1h1,                                                      eag03140
     . 20x,10a8//1x,16(1h*)/17h dynamic analysis /1x,16(1h*)///         eag03150
     . 50h0 code for ground motion component, ihv...........i5/         eag03160
     . 50h0 number of points for frequency response.........i5/         eag03170
     . 50h0 time step for response..........................f10.5,5h seceag03180
     ../ 50h0 wave reflection coef for reservoir bottom.......f10.5/    eag03190
     .   50h0 hysteretic damping factor for dam concrete......f10.5)    eag03200
 2071 format (60h0***** maximum frequency for  dynamic  stiffness  matrieag03210
     .x is ,f12.5,41h rad/sec,  too small for requested range. )        eag03220
 2080 format (1h1/20x,10a8//                                            eag03230
     . 55h0 number of ordinates for horizontal earthquake data...i5/    eag03240
     . 55h0 number of ordinates for   vertical earthquake data...i5/    eag03250
     . 55h0 time duration of response............................f10.3,5eag03260
     .h sec./)                                                          eag03270
 2090 format (1h1,                                                      eag03280
     . 20x,10a8//1x,32hcontrol information for response /               eag03290
     .         1x,32h--------------------------------//                 eag03300
     . 55h0 number of print intervals............................i4/    eag03310
     . 55h0 code for combining dynamic and static stresses.......i4/    eag03320
     . 55h0 code for selection of response print out.............i4/    eag03330
     . 55h0 nunber of   nodes  for which responses are printed...i4/    eag03340
     . 55h0 nunber of elements for which responses are printed...i4)    eag03350
 2095 format (////46h hydrodynamic effect of reservoir not included /)  eag03360
 2100 format (///1x,5(1h*),24h the foundation is rigid,5(1h*)//)        eag03370
      end                                                               eag03380
      subroutine comntr (z,ijbc,npp,ihyd,dt,wl,nterm)                   eag03390
c                                                                       eag03400
c     ******************************************************************eag03410
c     compute number of impounded water modes to use in analysis        eag03420
c     ******************************************************************eag03430
c                                                                       eag03440
      implicit real*8 (a-h,o-z)                                         eag03450
      dimension z(1),ijbc(1)                                            eag03460
      data cc/4720.0d0/,nterm1/5/                                       eag03470
c                                                                       eag03480
      nterm = 0                                                         eag03490
      if (ihyd.ne.0) return                                             eag03500
      lt = ijbc(npp)                                                    eag03510
      nterm = (wl-z(lt))/(cc*dt) + nterm1                               eag03520
      return                                                            eag03530
      end                                                               eag03540
      subroutine baneig(nn,mm,nev,nbc,ev,nebc,smass,a,b,v,r,cn,sn,trace)eag03550
c                                                                       eag03560
c     ******************************************************************eag03570
c     solve the symmetric banded eigenvalue problem                     eag03580
c     ******************************************************************eag03590
c                                                                       eag03600
      implicit real*8 (a-h,o-z)                                         eag03610
      dimension ev(1),nebc(1),smass(1), a(nn,1),b(1),r(1),sn(1),cn(1),  eag03620
     .          v(1)                                                    eag03630
c                                                                       eag03640
c     initialize                                                        eag03650
c                                                                       eag03660
      tol=1.0d-12                                                       eag03670
      iflag = 0                                                         eag03680
      nloop = 5                                                         eag03690
      nsmax = 50                                                        eag03700
      pshift = 0.d0                                                     eag03710
      mm1 = mm + 1                                                      eag03720
      nw = nn*mm                                                        eag03730
      neig = 0                                                          eag03740
      nr = nn                                                           eag03750
      nnr = nn - 1                                                      eag03760
      rewind 2                                                          eag03770
c                                                                       eag03780
c     reduce to classical eigenvalue problem  a*x = e*x                 eag03790
c                                                                       eag03800
      do 120  i = 1,nn                                                  eag03810
      x = smass(i)                                                      eag03820
      if (x.gt.0.)  go to 110                                           eag03830
      print 12, i                                                       eag03840
   12 format (30h0neg. or zero mass, equation = i5)                     eag03850
      iflag = 1                                                         eag03860
      go to 120                                                         eag03870
  110 smass(i) = 1./dsqrt(x)                                            eag03880
  120 continue                                                          eag03890
      if (iflag.ne.0)  stop                                             eag03900
      do 130  i = 1,nn                                                  eag03910
      l = i - 1                                                         eag03920
      mr = min0 (mm,nn-i+1)                                             eag03930
      do 130  j = 1,mr                                                  eag03940
      k = l + j                                                         eag03950
  130 a(i,j) = a(i,j)*smass(i)*smass(k)                                 eag03960
c                                                                       eag03970
c     impose boundary conditions on a                                   eag03980
c                                                                       eag03990
      if (nbc.le.0)  go to 150                                          eag04000
      do 140  n = 1,nbc                                                 eag04010
      i = nebc(n)                                                       eag04020
      a(i,1) = 100.*trace                                               eag04030
      do 140 j=2,mm                                                     eag04040
      a(i,j)=0.                                                         eag04050
      l=i-j+1                                                           eag04060
      if (l.le.0) go to 140                                             eag04070
      a(l,j)=0.                                                         eag04080
  140 continue                                                          eag04090
c                                                                       eag04100
c     compact matrix a into a one-dimensional array v                   eag04110
c                                                                       eag04120
  150 do 160  j = 1,mm                                                  eag04130
      l = nn*(j-1)                                                      eag04140
      m = nn - j + 1                                                    eag04150
      do 160  i = 1,m                                                   eag04160
      k = l + i                                                         eag04170
  160 v(k) = a(i,j)                                                     eag04180
      write (2) (v(i),i=1,nw)                                           eag04190
c                                                                       eag04200
c     compute smallest eigenvalue and associate eigenvector of a        eag04210
c     by inverse iteration                                              eag04220
c                                                                       eag04230
 1000 neig = neig + 1                                                   eag04240
      e1 = 0.                                                           eag04250
      shift = 0.                                                        eag04260
      ns = 0                                                            eag04270
      kkk = 2                                                           eag04280
      call bansol (nr,mm,nn,v,b,0)                                      eag04290
      do 170  i = nr,nn                                                 eag04300
  170 b(i) = 0.                                                         eag04310
      do 180  i = 1,nr                                                  eag04320
  180 b(i) = 1.                                                         eag04330
      if (nbc.le.0)  go to 200                                          eag04340
      do 190  n = 1,nbc                                                 eag04350
      i = nebc(n)                                                       eag04360
  190 b(i) = 0.                                                         eag04370
  200 ns = ns + 1                                                       eag04380
      call bansol (nr,mm,nn,v,b,kkk)                                    eag04390
      kkk = 1                                                           eag04400
      e = 0.                                                            eag04410
      do 220  i = 1,nr                                                  eag04420
      if (dabs(b(i)).gt.dabs(e))e = b(i)                                eag04430
  220 continue                                                          eag04440
      e = 1./e                                                          eag04450
      eps = (e-e1)/e*100.                                               eag04460
      do 230  i = 1,nr                                                  eag04470
  230 b(i) = b(i)*e                                                     eag04480
      e1 = e                                                            eag04490
      if (dabs(eps).gt.1..and.ns.lt.15)  go to 200                      eag04500
      nl = nloop - 3                                                    eag04510
  250 do 260  i = 1,nr                                                  eag04520
  260 r(i) = b(i)                                                       eag04530
      ns = ns + 1                                                       eag04540
      call bansol (nr,mm,nn,v,b,1)                                      eag04550
      e = 0.                                                            eag04560
      do 300  i = 1,nr                                                  eag04570
      if (dabs(b(i)).gt.dabs(e))e = b(i)                                eag04580
  300 continue                                                          eag04590
      dmax = 0.                                                         eag04600
      sumd = 0.                                                         eag04610
      do 320  i = 1,nr                                                  eag04620
      b(i) = b(i)/e                                                     eag04630
      d = dabs(b(i)-r(i))                                               eag04640
      if (d.gt.dmax)  dmax = d                                          eag04650
  320 sumd = sumd + d**2                                                eag04660
      if (dmax.le.tol.or.ns.ge.nsmax)  go to 400                        eag04670
      nl = nl + 1                                                       eag04680
      if (nl.lt.nloop)  go to 250                                       eag04690
      rewind 2                                                          eag04700
      read(2)  (v(i),i=1,nw)                                            eag04710
      nl = 0                                                            eag04720
      x = 0.                                                            eag04730
      y = 0.                                                            eag04740
      do 340  i = 1,nr                                                  eag04750
      x = x + b(i)*r(i)                                                 eag04760
  340 y = y + b(i)*b(i)                                                 eag04770
      shift = shift + dmax1(1.d0-4.d0*sumd,0.9d0)*x/(y*e)               eag04780
      do 350  i = 1,nr                                                  eag04790
  350 v(i) = v(i) - shift                                               eag04800
      call bansol (nr,mm,nn,v,b,0)                                      eag04810
      go to 250                                                         eag04820
  400 x = 0.                                                            eag04830
      y = 0.                                                            eag04840
      do 420  i = 1,nr                                                  eag04850
      x = x + b(i)*r(i)                                                 eag04860
  420 y = y + b(i)*b(i)                                                 eag04870
      shift = shift + x/(y*e)                                           eag04880
      ev(neig) = shift + pshift                                         eag04890
      shift = shift - tol                                               eag04900
      pshift = ev(neig) - tol                                           eag04910
      y = dsqrt(y)                                                      eag04920
      do 430  i = 1,nn                                                  eag04930
  430 r(i) = b(i)/y                                                     eag04940
      if (neig.ge.nev)  go to 650                                       eag04950
c                                                                       eag04960
c     deflate band matrix                                               eag04970
c                                                                       eag04980
      rewind 2                                                          eag04990
      read(2)  (v(i),i=1,nw)                                            eag05000
      do 450  nx = 1,nr                                                 eag05010
      fb = r(nx)                                                        eag05020
      if (fb.ne.0.)  go to 480                                          eag05030
  450 continue                                                          eag05040
  480 do 500  i = 1,nr                                                  eag05050
      l = nw + i                                                        eag05060
      v(i) = v(i) - shift                                               eag05070
  500 v(l) = 0.                                                         eag05080
      nrs = nr - 1                                                      eag05090
      nr1 = nr + 1                                                      eag05100
      q1 = r(1)**2                                                      eag05110
      s2 = 0.                                                           eag05120
      c  = 1.                                                           eag05130
      do 600  i = 1,nrs                                                 eag05140
      k = i + 1                                                         eag05150
      q = q1 + r(k)**2                                                  eag05160
      if (i.lt.nx)  go to 550                                           eag05170
      s2 = q1/q                                                         eag05180
      c = r(k)/dsqrt(q)                                                 eag05190
      if (fb.lt.0.)  c = -c                                             eag05200
  550 s = dsqrt(s2)                                                     eag05210
      c2 = c*c                                                          eag05220
      sn(i) = s                                                         eag05230
      cn(i) = c                                                         eag05240
      q1 = q                                                            eag05250
      l = nn + i                                                        eag05260
      a11 = v(i)                                                        eag05270
      a22 = v(k)                                                        eag05280
      a12 = v(l)                                                        eag05290
      x = 2.*a12*s*c                                                    eag05300
      v(i) = a11*c2 + a22*s2 - x                                        eag05310
      v(k) = a22*c2 + a11*s2 + x                                        eag05320
      v(l) = a12*(c2-s2) + (a11-a22)*s*c                                eag05330
      mr = min0 (i,mm)                                                  eag05340
      if (mr.le.1)  go to 570                                           eag05350
      l1 = i                                                            eag05360
      do 560  j = 2,mr                                                  eag05370
      l1 = l1 + nnr                                                     eag05380
      l2 = l1 + nn                                                      eag05390
      a1 = v(l1)                                                        eag05400
      a2 = v(l2)                                                        eag05410
      v(l1) = a1*c - a2*s                                               eag05420
  560 v(l2) = a2*c + a1*s                                               eag05430
  570 mr = min0 (mm1,nr1-i)                                             eag05440
      if (mr.lt.3)  go to 600                                           eag05450
      l2 = k                                                            eag05460
      do 580  j = 3,mr                                                  eag05470
      l2 = l2 + nn                                                      eag05480
      l1 = l2 + nnr                                                     eag05490
      a1 = v(l1)                                                        eag05500
      a2 = v(l2)                                                        eag05510
      v(l1) = a1*c - a2*s                                               eag05520
  580 v(l2) = a2*c + a1*s                                               eag05530
  600 continue                                                          eag05540
c                                                                       eag05550
c     deflated matrix, eigenvector, sines and cosines of                eag05560
c     jacobi rotation matrices are stored on tape                       eag05570
c                                                                       eag05580
      rewind 2                                                          eag05590
      write (2) (v(i),i=1,nw)                                           eag05600
      write (1) (r(i),sn(i),cn(i),i=1,nn)                               eag05610
      nr = nr - 1                                                       eag05620
      if (nbc.le.0)  go to 1000                                         eag05630
      do 620  n = 1,nbc                                                 eag05640
      i = nebc(n)                                                       eag05650
      if (i.ge.nx)  nebc(n) = i - 1                                     eag05660
  620 continue                                                          eag05670
      go to 1000                                                        eag05680
c                                                                       eag05690
c     recover eigenvectors of original matrix                           eag05700
c     and check eigenvalue arrangement                                  eag05710
c                                                                       eag05720
  650 do 700  i = 1,nn                                                  eag05730
  700 a(i,nev) = r(i)                                                   eag05740
      if (nev.le.1)  go to 900                                          eag05750
      ll = nev - 1                                                      eag05760
      do 800  n = 1,ll                                                  eag05770
      m = nev - n                                                       eag05780
      nrs = nn - m                                                      eag05790
      nr = nrs + 1                                                      eag05800
      backspace 1                                                       eag05810
      read  (1)(a(i,m),sn(i),cn(i),i=1,nn)                              eag05820
      backspace 1                                                       eag05830
      kk = m + 1                                                        eag05840
      do 800  l = 1,nrs                                                 eag05850
      i = nr - l                                                        eag05860
      k = i + 1                                                         eag05870
      do 800  j = kk,nev                                                eag05880
      a1 = a(i,j)                                                       eag05890
      a2 = a(k,j)                                                       eag05900
      a(i,j) = a1*cn(i) + a2*sn(i)                                      eag05910
  800 a(k,j) = a2*cn(i) - a1*sn(i)                                      eag05920
      do 830  k = 1,ll                                                  eag05930
      m = ll - k + 1                                                    eag05940
      do 830  j = 1,m                                                   eag05950
      e1 = ev(j)                                                        eag05960
      e2 = ev(j+1)                                                      eag05970
      if (e1.lt.e2)  go to 830                                          eag05980
      ev(j+1) = e1                                                      eag05990
      ev(j)   = e2                                                      eag06000
      do 820  i = 1,nn                                                  eag06010
      temp = a(i,j)                                                     eag06020
      a(i,j) = a(i,j+1)                                                 eag06030
  820 a(i,j+1) = temp                                                   eag06040
  830 continue                                                          eag06050
  900 do 920  i = 1,nn                                                  eag06060
      x = smass(i)                                                      eag06070
      smass(i) = 1./x**2                                                eag06080
      do 920  j = 1,nev                                                 eag06090
  920 a(i,j) = a(i,j)*x                                                 eag06100
      return                                                            eag06110
      end                                                               eag06120
      subroutine bansol (nn,mm,ndim,a,b,kkk)                            eag06130
c                                                                       eag06140
c     ****************************************************************  eag06150
c     in core linear equation solver for symmetric band matrices        eag06160
c      kkk = 0  triangularizes band matrix a                            eag06170
c      kkk = 1  reduces and backsubstitutes vector b                    eag06180
c      kkk = 2  backsubstitutes vector b                                eag06190
c     ****************************************************************  eag06200
c                                                                       eag06210
      implicit real*8 (a-h,o-z)                                         eag06220
      dimension a(ndim,1), b(1)                                         eag06230
      nr = nn - 1                                                       eag06240
      if (kkk-1)  100,300,400                                           eag06250
  100 do 200  n = 1,nr                                                  eag06260
      m = n - 1                                                         eag06270
      if (a(n,1).eq.0.)   a(n,1)  = 1.0d-16                             eag06280
      pivot = a(n,1)                                                    eag06290
      mr = min0 (mm,nn-m)                                               eag06300
      do 200  l = 2,mr                                                  eag06310
      c = a(n,l)/pivot                                                  eag06320
      if (c.eq.0.)  go to 200                                           eag06330
      i = m + l                                                         eag06340
      j = 0                                                             eag06350
      do 180  k = l,mr                                                  eag06360
      j = j + 1                                                         eag06370
  180 a(i,j) = a(i,j) - c*a(n,k)                                        eag06380
      a(n,l) = c                                                        eag06390
  200 continue                                                          eag06400
      if (a(nn,1).eq.0.)  a(nn,1) = 1.0d-16                             eag06410
      go to 500                                                         eag06420
  300 do 350  n = 1,nr                                                  eag06430
      m = n - 1                                                         eag06440
      mr = min0 (mm,nn-m)                                               eag06450
      c = b(n)                                                          eag06460
      b(n) = c/a(n,1)                                                   eag06470
      do 350  l = 2,mr                                                  eag06480
      i = m + l                                                         eag06490
  350 b(i) = b(i) - a(n,l)*c                                            eag06500
  400 b(nn) = b(nn)/a(nn,1)                                             eag06510
      do 450  k = 2,nn                                                  eag06520
      m = nn - k                                                        eag06530
      n = m + 1                                                         eag06540
      mr = min0 (mm,k)                                                  eag06550
      do 450  l = 2,mr                                                  eag06560
      i = m + l                                                         eag06570
  450 b(n) = b(n) - a(n,l)*b(i)                                         eag06580
  500 return                                                            eag06590
      end                                                               eag06600
      subroutine cinter (t,x,nx,n,dt,c)                                 eag06610
c                                                                       eag06620
c     ******************************************************************eag06630
c     interpolate t and x into c at dt intervals                        eag06640
c     ******************************************************************eag06650
c                                                                       eag06660
      implicit real*8 (a-h,o-z)                                         eag06670
      dimension t(1),x(1),c(1)                                          eag06680
c                                                                       eag06690
      c(1)=x(1)                                                         eag06700
      i=0                                                               eag06710
      t1=t(1)                                                           eag06720
c                                                                       eag06730
      do 10 j=2,n                                                       eag06740
c     tj=dfloat(j-1)*dt                                                 eag06750
      tj=dble(float(j-1))*dt                                            eag06760
    5 if (tj.le.t(i+1)-t1) go to 10                                     eag06770
      i=i+1                                                             eag06780
      if (i.ge.nx) return                                               eag06790
      scale=(x(i+1)-x(i))/(t(i+1)-t(i))                                 eag06800
      go to 5                                                           eag06810
   10 c(j)=x(i)+scale*(tj-t(i)+t1)                                      eag06820
      return                                                            eag06830
      end                                                               eag06840
      subroutine csymeq(a,b,nn,ll)                                      eag06850
c                                                                       eag06860
c     ******************************************************************eag06870
c     solve symmetric system of complex linear equations                eag06880
c     ******************************************************************eag06890
c                                                                       eag06900
      implicit real*8 (a-h,o-z)                                         eag06910
      complex*16 a(nn,1),b(nn,1),dum                                    eag06920
c                                                                       eag06930
      do 475 n=1,nn                                                     eag06940
      n1=n+1                                                            eag06950
      dum=1.0/a(n,n)                                                    eag06960
c                                                                       eag06970
      do 150 l=1,ll                                                     eag06980
  150 b(n,l)=b(n,l)*dum                                                 eag06990
c                                                                       eag07000
      if (n-nn) 200,500,200                                             eag07010
  200 do 450 j=n1,nn                                                    eag07020
      if (cdabs(a(n,j))) 250,450,250                                    eag07030
  250 a(n,j)=a(n,j)*dum                                                 eag07040
c                                                                       eag07050
      do 300 i=j,nn                                                     eag07060
      a(i,j)=a(i,j)-a(i,n)*a(n,j)                                       eag07070
  300 a(j,i)=a(i,j)                                                     eag07080
c                                                                       eag07090
      do 400 l=1,ll                                                     eag07100
  400 b(j,l)=b(j,l)-a(j,n)*b(n,l)                                       eag07110
  450 continue                                                          eag07120
  475 continue                                                          eag07130
c                                                                       eag07140
c     back-substitution                                                 eag07150
c                                                                       eag07160
  500 n1=n                                                              eag07170
      n=n-1                                                             eag07180
      if (n) 700,700,550                                                eag07190
  550 do 600 l=1,ll                                                     eag07200
      do 600 j=n1,nn                                                    eag07210
  600 b(n,l)=b(n,l)-a(n,j)*b(j,l)                                       eag07220
      go to 500                                                         eag07230
c                                                                       eag07240
  700 return                                                            eag07250
      end                                                               eag07260
      subroutine eigen (nebc,smass,ev,akf0,ibase,a,w1,w2,w3,w4,cc,      eag07270
     .                  escale,nb2,neq,nev,mban)                        eag07280
c                                                                       eag07290
c     ******************************************************************eag07300
C     compute mode shapes and frequencies                               eag07310
c     maximum number of modes = mband+1                                 eag07320
c     ******************************************************************eag07330
c                                                                       eag07340
      implicit real*8 (a-h,o-z)                                         eag07350
      common /cntrl1/ numnp,mband,numel,nbc,igrav,npp,wl,trace,iopr,    eag07360
     .                iopp,nbase,irig,xjunk(12)                         eag07370
      common /label/  hed(10)                                           eag07380
      dimension nebc(1),smass(1),a(neq,mban ),ev(1),w1(1),w2(1),w3(1),  eag07390
     .          w4(1),cc(nev,1),ibase(1)                                eag07400
      complex*16 akf0(nb2,nb2)                                          eag07410
c                                                                       eag07420
      if (irig.ne.0) go to 125                                          eag07430
      rewind 90                                                         eag07440
      read (90)                                                         eag07450
      read (90)                                                         eag07460
      read (90) akf0                                                    eag07470
      rewind 90                                                         eag07480
      do 110 i=1,nb2                                                    eag07490
      do 110 j=i,nb2                                                    eag07500
      akf0(i,j)=akf0(i,j)*escale                                        eag07510
  110 akf0(j,i)=akf0(i,j)                                               eag07520
c                                                                       eag07530
  125 if (iopr.ne.0) go to 220                                          eag07540
      if (igrav.ne.0) backspace 1                                       eag07550
      backspace 1                                                       eag07560
      read  (1) a                                                       eag07570
      if (igrav.ne.0) read (1)                                          eag07580
      if (irig.ne.0) go to 135                                          eag07590
c                                                                       eag07600
      do 130 i=1,nb2                                                    eag07610
      l=ibase(i)                                                        eag07620
      do 130 j=1,nb2                                                    eag07630
      k=ibase(j)-l+1                                                    eag07640
      if ((k.le.0).or.(k.gt.mband)) go to 130                           eag07650
      a(l,k)=a(l,k)+dreal(akf0(i,j))                                    eag07660
  130 continue                                                          eag07670
c                                                                       eag07680
c     solve for eigenvalues and eigenvectors                            eag07690
c                                                                       eag07700
  135 call baneig(neq,mband,nev,nbc,ev,nebc,smass,a,w1,a,w2,w3,w4,trace)eag07710
c                                                                       eag07720
c     output eigenvalues and eigenvectors                               eag07730
c                                                                       eag07740
      write (6,2006) hed                                                eag07750
      do 140 i=1,nev                                                    eag07760
      ev(i)=dsqrt(ev(i))                                                eag07770
  140 write (6,2005) i,ev(i)                                            eag07780
      write (6,2007)                                                    eag07790
      call mprint (a,neq,nev)                                           eag07800
      write (6,2008)                                                    eag07810
      do 190 i=1,nev                                                    eag07820
      do 160 j=i,nev                                                    eag07830
      sum=0.0                                                           eag07840
      do 150 k=1,neq                                                    eag07850
  150 sum=sum+a(k,i)*smass(k)*a(k,j)                                    eag07860
  160 cc(i,j)=sum                                                       eag07870
      ii=i-1                                                            eag07880
      if (ii) 190,190,170                                               eag07890
  170 do 180 l=1,ii                                                     eag07900
  180 cc(i,l)=cc(l,i)                                                   eag07910
  190 continue                                                          eag07920
      call mprint (cc,nev,nev)                                          eag07930
c                                                                       eag07940
      if (iopp.eq.0) return                                             eag07950
      do 200 n=1,nev                                                    eag07960
  200 write(15,2009) n,ev(n)                                            eag07970
      do 210 n=1,nev                                                    eag07980
      do 210 m=1,numnp                                                  eag07990
      l=m+m-1                                                           eag08000
  210 write(15,1020) m,a(l,n),a(l+1,n)                                  eag08010
      return                                                            eag08020
c                                                                       eag08030
c     read frequencies and modeshapes                                   eag08040
c                                                                       eag08050
  220 read  (5,1010) (ev(n),n=1,nev)                                    eag08060
      do 230 n=1,nev                                                    eag08070
      do 230 m=1,numnp                                                  eag08080
      l=m+m-1                                                           eag08090
  230 read  (5,1020) mm,a(l,n),a(l+1,n)                                 eag08100
      write (6,2006) hed                                                eag08110
      do 240 i=1,nev                                                    eag08120
  240 write (6,2005) i,ev(i)                                            eag08130
      write (6,2007)                                                    eag08140
      call mprint (a,neq,nev)                                           eag08150
      return                                                            eag08160
c                                                                       eag08170
 1010 format (12x,f15.8)                                                eag08180
 1020 format (1i12,2d15.6)                                              eag08190
 2005 format (2h0w,i3,1h=,1f15.5)                                       eag08200
 2006 format (1h1,20x,10a8//                                            eag08210
     . 1x,27(1h*)/28h frequencies and mode shapes/1x,27(1h*)///         eag08220
     . 50h frequencies (rad/sec) of dam with reservoir empty  /         eag08230
     . 50h ------------------------------------------------- //)        eag08240
 2007 format (68h1 eigenvectors (normalized with respect to the mass mateag08250
     .rix)-matrix a)                                                    eag08260
 2008 format (49h1 verification of orthogonality relation-at*m*a=i)     eag08270
 2009 format (1i12,f15.8)                                               eag08280
      end                                                               eag08290
      subroutine imnctr(f,a,b,c,d,nw,nbase,nj2,nj,nrec,rnu)             eag08300
c                                                                       eag08310
c     ******************************************************************eag08320
c     control generation of dynamic stiffness matrix from the           eag08330
c     compliance data stored on tape80                                  eag08340
c     ******************************************************************eag08350
c                                                                       eag08360
      implicit real*8 (a-h,o-z)                                         eag08370
      complex*16 f(nw,3,nbase),a(nj2,nj2),b(nj2,nj2),c(nj2,nj2),        eag08380
     .           d(nj2,nj2)                                             eag08390
c                                                                       eag08400
      nel=nbase-1                                                       eag08410
      nel2=nel+nel                                                      eag08420
      nn=nbase                                                          eag08430
      if (nbase.gt.nj) nn=nj                                            eag08440
c                                                                       eag08450
c     skip and read compliance data                                     eag08460
c                                                                       eag08470
      if (nrec.eq.0) go to 20                                           eag08480
      do 10 i=1,nrec                                                    eag08490
   10 read (80,99)                                                      eag08500
   20 read (80,99) (((f(i,j,k),i=1,nw),j=1,3),k=1,nn)                   eag08510
c                                                                       eag08520
      if (nbase.le.nj) go to 40                                         eag08530
      nn=nj+1                                                           eag08540
      do 30 k=nn,nbase                                                  eag08550
      do 30 j=1,3                                                       eag08560
      do 30 i=1,nw                                                      eag08570
   30 f(i,j,k)=0.0                                                      eag08580
c                                                                       eag08590
   40 call imfork (f,a,b,c,d,nw,nbase,nj2,nel,nel2,rnu)                 eag08600
      return                                                            eag08610
   99 format (4f18.14)                                                  eag08620
      end                                                               eag08630
      subroutine imfor4 (f,nw,inw,nj,nj2,nel,nel1,nel2,h)               eag08640
c                                                                       eag08650
c     ******************************************************************eag08660
c     form tranformation matrices                                       eag08670
c     ******************************************************************eag08680
c                                                                       eag08690
      implicit real*8 (a-h,o-z)                                         eag08700
      complex*16 f(nw,3,nj),h(nj2,nel2)                                 eag08710
c                                                                       eag08720
      istart=-1                                                         eag08730
      do 1 i=1,nel                                                      eag08740
      istart=istart+2                                                   eag08750
      j=0                                                               eag08760
      icol=istart                                                       eag08770
      do 1 irow=istart,nj2,2                                            eag08780
      j=j+1                                                             eag08790
      h (irow,icol)=f(inw,1,j)                                          eag08800
      h (irow+1,icol)=-f(inw,3,j)                                       eag08810
      h (irow,icol+1)=f(inw,3,j)                                        eag08820
1     h (irow+1,icol+1)=f(inw,2,j)                                      eag08830
      istart=-1                                                         eag08840
      do 2 i=1,nel1                                                     eag08850
      istart=istart+2                                                   eag08860
      irow=istart                                                       eag08870
      istar2=istart+2                                                   eag08880
      do 2 icol=istar2,nel2,2                                           eag08890
      h (irow,icol)=h (icol+2,irow)                                     eag08900
      h (irow+1,icol)=h (icol+2,irow+1)                                 eag08910
      h (irow,icol+1)=h (icol+3,irow)                                   eag08920
2     h (irow+1,icol+1)=h (icol+3,irow+1)                               eag08930
      return                                                            eag08940
      end                                                               eag08950
      subroutine imfork (f,a,b,c,d,nw,nj,nj2,nel,nel2,enu)              eag08960
c                                                                       eag08970
c     ******************************************************************eag08980
c     generate dynamic stiffness matrix                                 eag08990
c     ******************************************************************eag09000
c                                                                       eag09010
      implicit real*8 (a-h,o-z)                                         eag09020
      complex*16 f(nw,3,nj),b(nj2,nj2),c(nel2,nel2),d(nel2,nel2),       eag09030
     .        a(nj2,nel2)                                               eag09040
	  real*8 bre(nj2,nj2),bim(nj2,nj2)
      data e/1.0d0/                                                     eag09050
c                                                                       eag09060
      gmus=.125*e/(1.+enu)                                              eag09070
      nel1=nel-1                                                        eag09080
      ni=nj2-1                                                          eag09090
      nel0=nel2+1                                                       eag09100
c                                                                       eag09110
      do 10 inw=1,nw                                                    eag09120
      call imfor4 (f,nw,inw,nj,nj2,nel,nel1,nel2,a)                     eag09130
      do 1 i=1,nel2                                                     eag09140
      do 1 j=1,nel2                                                     eag09150
1     c(i,j)=.5*(a(i,j)+a(i+2,j))                                       eag09160
      do 2 i=1,nel2                                                     eag09170
      do 3 j=1,nel2                                                     eag09180
3     d(i,j)=(0.,0.)                                                    eag09190
2     d(i,i)=(1.,0.)                                                    eag09200
      call csymeq (c,d,nel2,nel2)                                       eag09210
      b(1,1)=gmus*d(1,1)                                                eag09220
      b(2,2)=gmus*d(2,2)                                                eag09230
      b(2,1)=gmus*d(2,1)                                                eag09240
      do 4 i=3,nel2                                                     eag09250
      do 4 j=1,2                                                        eag09260
4     b(i,j)=gmus*(d(i-2,j)+d(i,j))                                     eag09270
      do 5 i=3,nel2                                                     eag09280
      do 5 j=3,i                                                        eag09290
5     b(i,j)=gmus*(d(i-2,j-2)+d(i-2,j)+d(i,j-2)+d(i,j))                 eag09300
      do 7 i=nel0,nj2                                                   eag09310
      do 7 j=nel0,i                                                     eag09320
7     b(i,j)=gmus*d(i-2,j-2)                                            eag09330
      do 8 i=nel0,nj2                                                   eag09340
      do 8 j=1,2                                                        eag09350
8     b(i,j)=gmus*(d(i-2,j))                                            eag09360
      do 9 i=nel0,nj2                                                   eag09370
      do 9 j=3,nel2                                                     eag09380
9     b(i,j)=gmus*(d(i-2,j)+d(i-2,j-2))                                 eag09390
      do 6 i=1,ni                                                       eag09400
      i1=i+1                                                            eag09410
      do 6 j=i1,nj2                                                     eag09420
 6    b(i,j)=b(j,i)                                                     eag09430
c                                                                       eag09440
      write (90) b                                                      eag09450
      if (inw.eq.1) write (90) b                                        eag09460
10    continue                                                          eag09470
c                                                                       eag09480
      return                                                            eag09490
      end                                                               eag09500
      subroutine formk (akf,eig,ibase,dummy,akfi,nev,nb2,neq)           eag09510
c                                                                       eag09520
c     ******************************************************************eag09530
c     transform foundation impedance matrix using ritz vectors          eag09540
c     ******************************************************************eag09550
c                                                                       eag09560
      implicit real*8 (a-h,o-z)                                         eag09570
      complex*16 akf(nb2,1),dummy(nb2),akfi(nev,1),sum                  eag09580
      dimension eig(neq,1),ibase(1)                                     eag09590
c                                                                       eag09600
      do 130 i=1,nev                                                    eag09610
      do 110 j=1,nb2                                                    eag09620
      dummy(j)=0.0                                                      eag09630
      do 110 k=1,nb2                                                    eag09640
      l=ibase(k)                                                        eag09650
  110 dummy(j)=dummy(j)+eig(l,i)*akf(k,j)                               eag09660
c                                                                       eag09670
      do 130 k=i,nev                                                    eag09680
      sum=0.0                                                           eag09690
      do 120 j=1,nb2                                                    eag09700
      l=ibase(j)                                                        eag09710
  120 sum=sum+dummy(j)*eig(l,k)                                         eag09720
      akfi(k,i)=sum                                                     eag09730
  130 akfi(i,k)=sum                                                     eag09740
c                                                                       eag09750
      return                                                            eag09760
      end                                                               eag09770
      subroutine found (akf1,akf2,akf,ibase,a,dummy,s,w,escale,ntemp,   eag09780
     .                  nb2,nev,neq)                                    eag09790
c                                                                       eag09800
c     ******************************************************************eag09810
c     compute foundation impedance matrix to s                          eag09820
c     ******************************************************************eag09830
c                                                                       eag09840
      implicit real*8 (a-h,o-z)                                         eag09850
c
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c   Modification 2013: Increased number of allowable damping coefficients
c                      and a0-values
c   OLD:
c     common /afound/ nw,ndamp,a0csb(91),dmp(4)                         eag09860
c   NEW:
      common /afound/ nw,ndamp,a0csb(600),dmp(50)                       eag09860
c   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      complex*16 akf1(nev,1),akf2(nev,1),akf(nb2,nb2),dummy(1),s(nev,1) eag09870
      dimension a(neq,1),ibase(1)                                       eag09880
c                                                                       eag09890
      j = 0                                                             eag09900
   10 if (w.le.a0csb(ntemp+1)) go to 20                                 eag09910
      j = j + 1                                                         eag09920
      ntemp = ntemp + 1                                                 eag09930
      if (ntemp.ge.nw) go to 90                                         eag09940
      go to 10                                                          eag09950
   20 if (j.eq.0) go to 60                                              eag09960
c                                                                       eag09970
      if (j.eq.1) go to 40                                              eag09980
      j = j - 1                                                         eag09990
      do 30 k=1,j                                                       eag10000
   30 read (90) akf                                                     eag10010
      call formk (akf,a,ibase,dummy,akf2,nev,nb2,neq)                   eag10020
   40 do 50 i=1,nev                                                     eag10030
      do 50 k=i,nev                                                     eag10040
   50 akf1(k,i) = akf2(k,i)                                             eag10050
      read (90) akf                                                     eag10060
      call formk (akf,a,ibase,dummy,akf2,nev,nb2,neq)                   eag10070
c                                                                       eag10080
   60 zinta = (a0csb(ntemp+1) - w)/(a0csb(ntemp+1) - a0csb(ntemp))      eag10090
      zintb = escale*(1.0 - zinta)                                      eag10100
      zinta = escale*zinta                                              eag10110
      do 70 i=1,nev                                                     eag10120
      do 70 k=i,nev                                                     eag10130
      s(k,i) = s(k,i) + zinta*akf1(k,i) + zintb*akf2(k,i)               eag10140
   70 s(i,k) = s(k,i)                                                   eag10150
c                                                                       eag10160
      return                                                            eag10170
c                                                                       eag10180
   90 write (6,98) w                                                    eag10190
      stop                                                              eag10200
c                                                                       eag10210
   98 format ( 7h0omega=,f8.4,59h is greater than maximum foundation impeag10220
     .edance frequency          )                                       eag10230
      end                                                               eag10240
      subroutine joblog (mstor,nbcom,t1,t2,t3,t4,t5,t6)                 eag10250
c                                                                       eag10260
c     ******************************************************************eag10270
c     blank common storage and execution time                           eag10280
c     ******************************************************************eag10290
c                                                                       eag10300
      implicit real*8 (a-h,o-z)                                         eag10310
      common /label/ hed(10)                                            eag10320
c                                                                       eag10330
      t1=dmax1(0.0d0,t2-t1)                                             eag10340
      t2=dmax1(0.0d0,t3-t2)                                             eag10350
      t3=dmax1(0.0d0,t4-t3)                                             eag10360
      t4=dmax1(0.0d0,t5-t4)                                             eag10370
      t5=dmax1(0.0d0,t6-t5)                                             eag10380
      t6=t1+t2+t3+t4+t5                                                 eag10390
      write (6,2000) hed,mstor,nbcom,t1,t2,t3,t4,t5,t6                  eag10400
      return                                                            eag10410
c                                                                       eag10420
 2000 format (1h1,20x,10a8//26x,11(1h*)/                                eag10430
     .        26x,11hj o b l o g /26x,11(1h*)//                         eag10440
     .         7x,49h***  blank common storage and execution time  ***//eag10450
     .         5x,44hblank common storage available             =,i8/   eag10460
     .         5x,44hblank common storage required              =,i8//  eag10470
     .         5x,14hexecution time //                                  eag10480
     .        10x,44hform foundation dynamic impedance matrix   =,f8.3/ eag10490
     .        10x,44hform stiffness and solve for static loads  =,f8.3/ eag10500
     .        10x,44hcompute frequencies and mode shapes        =,f8.3/ eag10510
     .        10x,44hcomplex frequency response functions       =,f8.3/ eag10520
     .        10x,44hearthquake response                        =,f8.3/ eag10530
     .        10x,44htotal execution time                       =,f8.3) eag10540
      end                                                               eag10550
      subroutine komplx (z,ijbc,smass,ev,akf0,ibase,a,akf1,akf2,akf,    eag10560
     .    dummy,hy,s,temp,sfo,a2,q,lam1,lam2,ei1,ei2,term,cdm1,cdm2,    eag10570
     .    rsum1,eid,ybuf,alpha,dfac1,sgn,nev,nev1,neq,nterm,nbu,        eag10580
     .    escale,nb2)                                                   eag10590
c                                                                       eag10600
c     ******************************************************************eag10610
c     compute complex-valued frequency response functions for the       eag10620
c     generalized coordinates                                           eag10630
c     ******************************************************************eag10640
c                                                                       eag10650
      implicit real*8 (a-h,o-z)                                         eag10660
      common /cntrl1/ numnp,mband,numel,nbc,igrav,npp,wl,trace,iopr,    eag10670
     .                iopp,nbase,irig,xjunk(12)                         eag10680
      common /cntrl2/ ndata,nwr,dt,nrest,nbuf,nblock,ihv,ncomp,njunk(4) eag10690
      common /label/  hed(10)                                           eag10700
c                                                                       eag10710
      dimension z(1),ijbc(1),smass(1),ev(1),a(neq,nev),a2(1),q(nev,1),  eag10720
     .          rsum1(1),hacc(6,2),ibase(1)                             eag10730
c                                                                       eag10740
      complex*16 hy(nev,1),s(nev,1),term2,ybuf(nbu,1),akf0(nb2,1),      eag10750
     .        akf(nb2,nb2),akf1(nev,1),akf2(nev,1),dummy(1),            eag10760
     .        sfo(nev,1),lam1(1),lam2(1),ei1(nev1,1),ei2(nev1,1),       eag10770
     .        temp(1),term(1),cdm1(1),cdm2(1),eid(1),facv,dum,bw1       eag10780
      logical rigbot,lihv                                               eag10790
c                                                                       eag10800
      data pi/3.14159265358979d0/,cc/4720.0d0/,delfac/0.25d0/           eag10810
c                                                                       eag10820
      bw1=dcmplx(1.0d0,dfac1)                                           eag10830
      do 50 i=1,nev                                                     eag10840
      do 50 j=1,nev                                                     eag10850
   50 sfo(i,j)=0.                                                       eag10860
      rigbot=.true.                                                     eag10870
c                                                                       eag10880
c     generalized constants and vector q                                eag10890
c                                                                       eag10900
      do 260 m=1,nev                                                    eag10910
      a2(m)=ev(m)*ev(m)                                                 eag10920
      sum1=0.                                                           eag10930
      sum2=0.                                                           eag10940
      do 255 j=1,numnp                                                  eag10950
      jj=j+j                                                            eag10960
      l=jj-1                                                            eag10970
      sum1=sum1+a(l ,m)*smass(l )                                       eag10980
  255 sum2=sum2+a(jj,m)*smass(jj)                                       eag10990
      if (ihv-1) 258,259,257                                            eag11000
  257 q(m,2)=-sum2                                                      eag11010
  258 q(m,1)=-sum1                                                      eag11020
      go to 260                                                         eag11030
  259 q(m,1)=-sum2                                                      eag11040
  260 continue                                                          eag11050
c                                                                       eag11060
c     set imaginary part of akf0 to be zero                             eag11070
c     in subsequent computations the same storage is used as complex    eag11080
c                                                                       eag11090
      if(irig.ne.0) go to 261                                           eag11100
      do 1 ii=1,nb2                                                     eag11110
      do 1 jj=ii,nb2                                                    eag11120
      akf0(ii,jj)=dcmplx(dreal(akf0(ii,jj)),0.0d0)                      eag11130
    1 akf0(jj,ii)=akf0(ii,jj)                                           eag11140
      call formk(akf0,a,ibase,dummy,sfo,nev,nb2,neq)                    eag11150
c                                                                       eag11160
c     position tape90                                                   eag11170
c                                                                       eag11180
      read(90)                                                          eag11190
      read(90)                                                          eag11200
      read (90) akf                                                     eag11210
      call formk (akf,a,ibase,dummy,akf1,nev,nb2,neq)                   eag11220
      read (90) akf                                                     eag11230
      call formk (akf,a,ibase,dummy,akf2,nev,nb2,neq)                   eag11240
      ntemp=1                                                           eag11250
c                                                                       eag11260
c     write mode shape array on tape                                    eag11270
c                                                                       eag11280
261   write (1) a                                                       eag11290
      if (npp.eq.0) go to 250                                           eag11300
c                                                                       eag11310
c     compute parameters for impounded water                            eag11320
c                                                                       eag11330
      rho=.0624/32.2                                                    eag11340
      const=sgn*rho                                                     eag11350
      rho2=2.0*rho                                                      eag11360
      qc=(1.0-alpha)/(1.0+alpha)                                        eag11370
      if (alpha.lt.1.0) rigbot =.false.                                 eag11380
      lt=ijbc(npp)                                                      eag11390
      h=wl-z(lt)                                                        eag11400
      qch=qc*h/cc                                                       eag11410
      hhcc=h*h/(cc*cc)                                                  eag11420
      delomg=1.0                                                        eag11430
      if (.not.rigbot) delomg = 0.50*pi*delfac/qch                      eag11440
c                                                                       eag11450
c     modify value of a at first upstream nodal point                   eag11460
c                                                                       eag11470
      i=ijbc(1)                                                         eag11480
      j=ijbc(2)                                                         eag11490
      ii=i+i-1                                                          eag11500
      jj=j+j-1                                                          eag11510
      wlij=(wl-z(j))/(z(i)-z(j))                                        eag11520
      do 100 k=1,nev                                                    eag11530
  100 a(ii,k)=a(jj,k)+(a(ii,k)-a(jj,k))*wlij                            eag11540
      z(i)=wl                                                           eag11550
c                                                                       eag11560
c     compute eigenproperties of impounded water for                    eag11570
c     zero frequency                                                    eag11580
c                                                                       eag11590
      do 110 n=1,nterm                                                  eag11600
 110  lam2(n)=dble(float(2*n-1))*pi/2.                                  eag11610
      call kpeign (lam2,ei2,a,z,ijbc,cdm1,cdm2,nterm,nterm,nev,nev1,    eag11620
     .             neq,npp,0.0,h)                                       eag11630
c                                                                       eag11640
c     set up frequency increments for frequency responses               eag11650
c                                                                       eag11660
  250 dom = pi/(dble(float(ndata))*dt)                                  eag11670
      write (6,2010)hed                                                 eag11680
      mnev=nev                                                          eag11690
      if (nev.gt.6) mnev=6                                              eag11700
      iblank=(mnev-1)*10                                                eag11710
c     encode (60,2020,fmt) iblank                                       eag11720
c     write (6,fmt) ((j,j=1,mnev),i=1,ncomp)                            eag11730
      write (6,2020) ((j,j=1,mnev),i=1,ncomp)                           eag11740
c                                                                       eag11750
      ll    =0                                                          eag11760
      mm    =0                                                          eag11770
      nblock=0                                                          eag11780
      nb=2*nbuf                                                         eag11790
      nfr=ndata+1                                                       eag11800
      nev2=(nev*nev1)/2                                                 eag11810
      omega=0.                                                          eag11820
      omega2=0.0                                                        eag11830
      lihv=.true.                                                       eag11840
      if (ihv.eq.1) lihv=.false.                                        eag11850
      rewind 2                                                          eag11860
      rewind 3                                                          eag11870
c                                                                       eag11880
c     compute response function(s) for each excitation frequency        eag11890
c                                                                       eag11900
      do 570 kkk=1,nfr                                                  eag11910
      om2=omega**2                                                      eag11920
c                                                                       eag11930
c     initialize s(omega) and load vector                               eag11940
c                                                                       eag11950
      do 320 m=1,nev                                                    eag11960
      do 305 i=1,ncomp                                                  eag11970
  305 hy(m,i)=dcmplx(q(m,i),0.0d0)                                      eag11980
      s(m,m)=-om2+(a2(m)-sfo(m,m))*bw1                                  eag11990
      if (m.ge.nev) go to 320                                           eag12000
      m1=m+1                                                            eag12010
      do 310 n=m1,nev                                                   eag12020
      s(m,n)=-sfo(m,n)*bw1                                              eag12030
310   s(n,m)=s(m,n)                                                     eag12040
320   continue                                                          eag12050
c                                                                       eag12060
      if (npp.eq.0) go to 500                                           eag12070
      if (ihv.eq.0) go to 450                                           eag12080
      omc=omega/cc                                                      eag12090
      call kpvert (rsum1,a,z,ijbc,nev,neq,npp,omc,h)                    eag12100
      i=1                                                               eag12110
      if (ihv.eq.2) i=2                                                 eag12120
      arg = omc*h                                                       eag12130
      if (omega.eq.0.0) facv=0.50*const                                 eag12140
      if (omega.gt.0.0) facv=(const/(omc*omc))/                         eag12150
     .   dcmplx(dcos(arg),qc*dsin(arg))                                 eag12160
      do 420 m=1,nev                                                    eag12170
420   hy(m,i) = hy(m,i)+facv*rsum1(m)                                   eag12180
c                                                                       eag12190
c     compute eigenproperties for next frequency interval               eag12200
c     if necessary                                                      eag12210
c                                                                       eag12220
450   if(omega.lt.omega2.or.rigbot) go to 444                           eag12230
      omega2=omega2+delomg                                              eag12240
      do 442 n=1,nterm                                                  eag12250
      lam1(n)=lam2(n)                                                   eag12260
      do 442 m=1,nev1                                                   eag12270
442   ei1(m,n)=ei2(m,n)                                                 eag12280
      call kpeign (lam2,ei2,a,z,ijbc,cdm1,cdm2,nterm,nterm,nev,nev1,    eag12290
     .             neq,npp,omega2*qch,h)                                eag12300
c                                                                       eag12310
c     interpolate eigenvalues and compute terms                         eag12320
c                                                                       eag12330
444   zinta=(omega2-omega)/delomg                                       eag12340
      zintb=1.0-zinta                                                   eag12350
      do 445 m=1,nev2                                                   eag12360
445   temp(m)=0.0                                                       eag12370
      omhc2=om2*hhcc                                                    eag12380
      if (rigbot) go to 447                                             eag12390
      omqh=omega*qch                                                    eag12400
      omqh2=omqh*omqh                                                   eag12410
      do 446 n=1,nterm                                                  eag12420
      dum=zinta*lam1(n)+zintb*lam2(n)                                   eag12430
      dum=dum*dum                                                       eag12440
446   term(n)=rho2*dum/((dum+dcmplx(-omqh2,omqh))*cdsqrt(dum-omhc2))    eag12450
      go to 449                                                         eag12460
447   do 448 n=1,nterm                                                  eag12470
      rdum=dreal(lam2(n))                                               eag12480
448   term(n)=rho2/cdsqrt(dcmplx(rdum*rdum-omhc2,0.0d0))                eag12490
c                                                                       eag12500
c     compute hydrodynamic terms                                        eag12510
c                                                                       eag12520
449   do 460 n=1,nterm                                                  eag12530
      if (rigbot) go to 453                                             eag12540
      do 452 m=1,nev1                                                   eag12550
452   eid(m)=zinta*ei1(m,n)+zintb*ei2(m,n)                              eag12560
      go to 454                                                         eag12570
453   do 458 m=1,nev1                                                   eag12580
458   eid(m)=ei2(m,n)                                                   eag12590
454   kpt=0                                                             eag12600
      do 460 m=1,nev                                                    eag12610
      dum=eid(m+1)*term(n)                                              eag12620
      if (lihv) hy(m,1)=hy(m,1)-dum*eid(1)                              eag12630
      do 460 k=m,nev                                                    eag12640
      kpt=kpt+1                                                         eag12650
460   temp(kpt)=temp(kpt)+dum*eid(k+1)                                  eag12660
c                                                                       eag12670
c     add hydrodynamic terms to s                                       eag12680
c                                                                       eag12690
      kpt=0                                                             eag12700
      do 468 m=1,nev                                                    eag12710
      do 468 k=m,nev                                                    eag12720
      kpt=kpt+1                                                         eag12730
      s(m,k)=s(m,k)-om2*temp(kpt)                                       eag12740
468   s(k,m)=s(m,k)                                                     eag12750
c                                                                       eag12760
c     add contribution due to foundation flexibility                    eag12770
c                                                                       eag12780
  500 if (irig.eq.0) call found (akf1,akf2,akf,ibase,a,dummy,s,omega,   eag12790
     .               escale,ntemp,nb2,nev,neq)                          eag12800
c                                                                       eag12810
c     solve for generalized displacements                               eag12820
c                                                                       eag12830
      call csymeq(s,hy,nev,ncomp)                                       eag12840
c                                                                       eag12850
      do 505 i=1,ncomp                                                  eag12860
      do 505 m=1,mnev                                                   eag12870
  505 hacc(m,i)=om2*cdabs(hy(m,i))                                      eag12880
      write (6,2040) omega,((hacc(m,i),m=1,mnev),i=1,ncomp)             eag12890
c                                                                       eag12900
      ll=ll+1                                                           eag12910
      do 520 kk=1,nev                                                   eag12920
      mm=mm+1                                                           eag12930
      do 520 i=1,ncomp                                                  eag12940
  520 ybuf(mm,i)=hy(kk,i)                                               eag12950
      if (ll.ne.nwr) go to 530                                          eag12960
c                                                                       eag12970
c     write frequency responses on tape                                 eag12980
c                                                                       eag12990
      do 525 i=1,ncomp                                                  eag13000
      if (i.eq.1) itape=2                                               eag13010
      if (i.eq.2) itape=3                                               eag13020
  525 call writey(ybuf(1,i),nb,itape)                                   eag13030
      nblock=nblock+1                                                   eag13040
      ll=0                                                              eag13050
      mm=0                                                              eag13060
  530 omega=omega+dom                                                   eag13070
  570 continue                                                          eag13080
                                                                        eag13090
      nrest=nfr-nwr*nblock                                              eag13100
      if (nrest.eq.0) return                                            eag13110
      nr=2*nrest*nev                                                    eag13120
      do 590 i=1,ncomp                                                  eag13130
      if (i.eq.1) itape=2                                               eag13140
      if (i.eq.2) itape=3                                               eag13150
  590 call writey(ybuf(1,i),nr,itape)                                   eag13160
c                                                                       eag13170
      return                                                            eag13180
c                                                                       eag13190
 2010 format (1h1,                                                      eag13200
     . 20x,10a8// 80h absolute value of frequency responses for generalieag13210
     .zed accelerations of the dam    /                                 eag13220
     .            80h --------------------------------------------------eag13230
     .----------------------------    // )                              eag13240
c2020 format (19h(10x,10hhorz.excit,i3,37hx,10hvert.excit//,5x,5homega, eag13250
c    .12i10/)  )                                                        eag13260
 2020 format (10x,10hhorz.excit,50x,10hvert.excit//,5x,5homega,12i10/)  eag13270
 2040 format (13(1x,f9.4))                                              eag13280
      end                                                               eag13290
      subroutine kpeign (lam2,ei2,a,z,ijbc,sum1,sum2,nterm,nterm1,nev,  eag13300
     .                   nev1,neq,npp,omqh,h)                           eag13310
c                                                                       eag13320
c     ******************************************************************eag13330
c     compute eigenvalues and participation factors of the impounded    eag13340
c     water in the reservoir                                            eag13350
c     ******************************************************************eag13360
c                                                                       eag13370
      implicit real*8 (a-h,o-z)                                         eag13380
      dimension lam2(1),ei2(nev1,1),a(neq,1),z(1),ijbc(1),sum1(1),      eag13390
     .          sum2(1)                                                 eag13400
      complex*16 lam2,ei2,sum1,sum2,x0,x1,x2,x3,lnl,wp,wn,s1,c1,e,ep,en,eag13410
     .        s2,c2,cz21,d1,d2,two,i                                    eag13420
      equivalence (x0,wp),(x1,wp),(x2,ep),(x3,en)                       eag13430
      data nmax/20/,tol/1.0d-7/,two/(0.0,2.0)/,i/(0.0,1.0)/             eag13440
c                                                                       eag13450
c     compute eigenvalues using newton-raphson method                   eag13460
c                                                                       eag13470
      do 30 l=1,nterm                                                   eag13480
      x0 = lam2(l)                                                      eag13490
      x2 = cdexp(two*x0)                                                eag13500
      c1 = x0 + omqh                                                    eag13510
      x3 = x2 + (x0-omqh)/c1                                            eag13520
      do 10 n=1,nmax                                                    eag13530
      x1 = x0 - 0.50*x3/(i*x2+omqh/(c1*c1))                             eag13540
      x2 = cdexp(two*x1)                                                eag13550
      c1 = x1 + omqh                                                    eag13560
      x3 = x2 + (x1-omqh)/c1                                            eag13570
      if (cdabs(x1-x0).lt.tol.and.cdabs(x3).lt.tol) go to 20            eag13580
      x0 = x1                                                           eag13590
   10 continue                                                          eag13600
      write (6,99) l, omqh                                              eag13610
   20 lam2(l) = x1                                                      eag13620
   30 continue                                                          eag13630
c                                                                       eag13640
c     compute participation factors i(n,l)                              eag13650
c                                                                       eag13660
      nelmnt = npp - 1                                                  eag13670
      lt = ijbc(npp)                                                    eag13680
      z0 = z(lt)                                                        eag13690
      do 80 l=1,nterm1                                                  eag13700
      do 40 n=1,nev                                                     eag13710
      sum1(n) = 0.0                                                     eag13720
   40 sum2(n) = 0.0                                                     eag13730
      lnl = lam2(l)                                                     eag13740
      wp = lnl + omqh                                                   eag13750
      wn = lnl - omqh                                                   eag13760
      s1 = 2.0*omqh                                                     eag13770
      c1 = 2.0*lnl                                                      eag13780
      do 60 k=1,nelmnt                                                  eag13790
      i1 = ijbc(npp-k+1)                                                eag13800
      j1 = ijbc(npp-k  )                                                eag13810
      i2 = i1 + i1 - 1                                                  eag13820
      j2 = j1 + j1 - 1                                                  eag13830
      e = cdexp(i*lnl*((z(j1)-z0)/h))                                   eag13840
      ep = wp*e                                                         eag13850
      en = wn/e                                                         eag13860
      s2 = ep - en                                                      eag13870
      c2 = ep + en                                                      eag13880
      cz21 = (c2-c1)/(z(j1)-z(i1))                                      eag13890
      do 50 n=1,nev                                                     eag13900
      sum1(n) = sum1(n) + a(j2,n)*s2 - a(i2,n)*s1                       eag13910
   50 sum2(n) = sum2(n) + cz21*(a(j2,n)-a(i2,n))                        eag13920
      s1 = s2                                                           eag13930
   60 c1 = c2                                                           eag13940
      d2 = (i*h)/lnl                                                    eag13950
      d1 = -0.50*d2/lnl                                                 eag13960
      do 70 n=1,nev                                                     eag13970
   70 ei2(n+1,l) = d1*(sum1(n)+d2*sum2(n))                              eag13980
   80 ei2(  1,l) = d1*(s2-2.0*omqh)                                     eag13990
      return                                                            eag14000
c                                                                       eag14010
   99 format (1h0,60h***** eigenvalue did not converge, computation proceag14020
     .eding (n= ,i3,6h omqh=,f12.6,7h) ***** )                          eag14030
      end                                                               eag14040
      subroutine kpvert (sum1,a,z,ijbc,nev,neq,npp,omc,h)               eag14050
c                                                                       eag14060
c     ******************************************************************eag14070
c     compute hydrodynamic force due to vertical ground motion          eag14080
c     ******************************************************************eag14090
c                                                                       eag14100
      implicit real*8 (a-h,o-z)                                         eag14110
      dimension sum1(1),a(neq,1),z(1),ijbc(1)                           eag14120
      equivalence (c1,z1),(c2,z2),(sz21,z21p),(arg,z21m),(lt,z213)      eag14130
c                                                                       eag14140
      nelmnt = npp - 1                                                  eag14150
      lt = ijbc(npp)                                                    eag14160
      z0 = z(lt)                                                        eag14170
      do 10 n=1,nev                                                     eag14180
   10 sum1(n) = 0.0                                                     eag14190
      if (omc.eq.0.0) go to 40                                          eag14200
c                                                                       eag14210
      arg = omc*h                                                       eag14220
      c1 = dcos(arg)                                                    eag14230
      s1 = dsin(arg)                                                    eag14240
      do 30 k=1,nelmnt                                                  eag14250
      i1 = ijbc(npp-k+1)                                                eag14260
      j1 = ijbc(npp-k  )                                                eag14270
      i2 = i1 + i1 - 1                                                  eag14280
      j2 = j1 + j1 - 1                                                  eag14290
      arg = omc*(h-z(j1)+z0)                                            eag14300
      c2 = dcos(arg)                                                    eag14310
      s2 = dsin(arg)                                                    eag14320
      sz21 = (s2-s1)/(omc*(z(j1)-z(i1)))                                eag14330
      do 20 n=1,nev                                                     eag14340
   20 sum1(n) = sum1(n) + (a(j2,n)*c2-a(i2,n)*c1)                       eag14350
     .                  + sz21*(a(j2,n)-a(i2,n))                        eag14360
      c1 = c2                                                           eag14370
   30 s1 = s2                                                           eag14380
      return                                                            eag14390
c                                                                       eag14400
   40 z1 = 0.0                                                          eag14410
      tt = 2.0/3.0                                                      eag14420
      do 60 k=1,nelmnt                                                  eag14430
      i1 = ijbc(npp-k+1)                                                eag14440
      j1 = ijbc(npp-k  )                                                eag14450
      i2 = i1 + i1 - 1                                                  eag14460
      j2 = j1 + j1 - 1                                                  eag14470
      z2 = z(j1) - z0                                                   eag14480
      z21p = z2 + z1                                                    eag14490
      z21m = (z2-z1)*h                                                  eag14500
      z213 = (z2*z2+z2*z1+z1*z1)*tt                                     eag14510
      do 50 n=1,nev                                                     eag14520
   50 sum1(n) = sum1(n) + (a(j2,n)+a(i2,n))*z21m                        eag14530
     .                  - (a(i2,n)*z2-a(j2,n)*z1)*z21p                  eag14540
     .                  - (a(j2,n)-a(i2,n))*z213                        eag14550
   60 z1 = z2                                                           eag14560
      return                                                            eag14570
      end                                                               eag14580
      subroutine mprint (a,nr,nc)                                       eag14590
c                                                                       eag14600
c     ******************************************************************eag14610
c     subroutine to print matrices                                      eag14620
c     ******************************************************************eag14630
c                                                                       eag14640
      implicit real*8 (a-h,o-z)                                         eag14650
      dimension a( nr,1)                                                eag14660
      do 100 j=1,nc,8                                                   eag14670
      jh=j+7                                                            eag14680
      if(jh-nc) 75,75,50                                                eag14690
   50 jh=nc                                                             eag14700
   75 write (6,1000) (n,n=j,jh)                                         eag14710
      do 100 i=1,nr                                                     eag14720
  100 write (6,1001) i,(a(i,k),k=j,jh)                                  eag14730
      return                                                            eag14740
c                                                                       eag14750
 1000 format (/// 8x, 8i14)                                             eag14760
 1001 format (1x,i4,3x,8d14.7)                                          eag14770
      end                                                               eag14780
      subroutine quad (r1,r2,r3,r4,z1,z2,z3,z4,rm,zm,elmass,d,qk,qc,q,  eag14790
     .                 rho,igrav)                                       eag14800
c                                                                       eag14810
c     ******************************************************************eag14820
c     forms stiffness matrix qk, centroidal stress matrix qc            eag14830
c     and load vector for an incompatible isoparametric                 eag14840
c     quadrilateral element using a four point integration formula      eag14850
c     ******************************************************************eag14860
c                                                                       eag14870
      implicit real*8 (a-h,o-z)                                         eag14880
      dimension qk(8,8),qc(3,8),d(3,3),tt(4),b(3,12),ss(4),qq(12,12),   eag14890
     .          p(12),q(8),elmass(4)                                    eag14900
      logical  triang                                                   eag14910
      data ss/-1.,1.,1.,-1./,tt/-1.,-1.,1.,1. /                         eag14920
c                                                                       eag14930
      fz=-rho*32.2                                                      eag14940
c                                                                       eag14950
c     initialize                                                        eag14960
c                                                                       eag14970
      do 15 j=1,12                                                      eag14980
      p(j)=0.0                                                          eag14990
      do 10 i=1,3                                                       eag15000
   10 b(i,j)=0.0                                                        eag15010
      do 15 i=1,12                                                      eag15020
   15 qq(i,j)=0.0                                                       eag15030
c                                                                       eag15040
      r12=r1-r2                                                         eag15050
      r13=r1-r3                                                         eag15060
      r14=r1-r4                                                         eag15070
      r23=r2-r3                                                         eag15080
      r24=r2-r4                                                         eag15090
      r34=r3-r4                                                         eag15100
      z12=z1-z2                                                         eag15110
      z13=z1-z3                                                         eag15120
      z14=z1-z4                                                         eag15130
      z23=z2-z3                                                         eag15140
      z24=z2-z4                                                         eag15150
      z34=z3-z4                                                         eag15160
      vol=r13*z24-r24*z13                                               eag15170
      rm=(r1+r2+r3+r4)/4.0                                              eag15180
      zm=(z1+z2+z3+z4)/4.0                                              eag15190
      pzt0=-(z14+z23)                                                   eag15200
      prt0=-(r14+r23)                                                   eag15210
      pzs0=-(z12-z34)                                                   eag15220
      prs0=-(r12-r34)                                                   eag15230
c                                                                       eag15240
c     check if element is triangular                                    eag15250
c                                                                       eag15260
      triang=.false.                                                    eag15270
      if (r14.eq.0.0.and.z14.eq.0.0) triang=.true.                      eag15280
c                                                                       eag15290
c     loop over 2x2 gauss quadrature points                             eag15300
c                                                                       eag15310
      do 500 ii=1,4                                                     eag15320
      s=ss(ii)*0.577350269189626d0                                      eag15330
      t=tt(ii)*0.577350269189626d0                                      eag15340
      sm=1.0-s                                                          eag15350
      sp=1.0+s                                                          eag15360
      tm=1.0-t                                                          eag15370
      tp=1.0+t                                                          eag15380
      h1=sm*tm                                                          eag15390
      h2=sp*tm                                                          eag15400
      h3=sp*tp                                                          eag15410
      h4=sm*tp                                                          eag15420
c                                                                       eag15430
      pzt=-(sm*z14+sp*z23)/4.0                                          eag15440
      prt=-(sm*r14+sp*r23)/4.0                                          eag15450
      pzs=-(tm*z12-tp*z34)/4.0                                          eag15460
      prs=-(tm*r12-tp*r34)/4.                                           eag15470
      xj=prs*pzt-prt*pzs                                                eag15480
      x1=pzt/xj                                                         eag15490
      x2=-pzs/xj                                                        eag15500
      x3=-prt/xj                                                        eag15510
      x4=prs/xj                                                         eag15520
c                                                                       eag15530
c     strain displacement transformation                                eag15540
c                                                                       eag15550
      b(1,1)=-tm*x1-sm*x2                                               eag15560
      b(1,3)= tm*x1-sp*x2                                               eag15570
      b(1,5)= tp*x1+sp*x2                                               eag15580
      b(1,7)=-tp*x1+sm*x2                                               eag15590
      b(2,2)=-tm*x3-sm*x4                                               eag15600
      b(2,4)= tm*x3-sp*x4                                               eag15610
      b(2,6)= tp*x3+sp*x4                                               eag15620
      b(2,8)=-tp*x3+sm*x4                                               eag15630
      b(3,1)=b(2,2)                                                     eag15640
      b(3,3)=b(2,4)                                                     eag15650
      b(3,5)=b(2,6)                                                     eag15660
      b(3,7)=b(2,8)                                                     eag15670
      b(3,2)=b(1,1)                                                     eag15680
      b(3,4)=b(1,3)                                                     eag15690
      b(3,6)=b(1,5)                                                     eag15700
      b(3,8)=b(1,7)                                                     eag15710
      if (triang) go to 300                                             eag15720
c                                                                       eag15730
c     include incompatible modes                                        eag15740
c                                                                       eag15750
      ss2=-(s+s)/xj                                                     eag15760
      tt2=-(t+t)/xj                                                     eag15770
      b(1, 9)= pzt0*ss2                                                 eag15780
      b(1,10)=-pzs0*tt2                                                 eag15790
      b(2,11)=-prt0*ss2                                                 eag15800
      b(2,12)= prs0*tt2                                                 eag15810
      b(3, 9)= b(2,11)                                                  eag15820
      b(3,10)= b(2,12)                                                  eag15830
      b(3,11)= b(1, 9)                                                  eag15840
      b(3,12)= b(1,10)                                                  eag15850
  300 continue                                                          eag15860
c                                                                       eag15870
c     the enlarged stiffness matrix                                     eag15880
c                                                                       eag15890
      fac=xj/16.0                                                       eag15900
      do 400 j=1,12                                                     eag15910
      d1=(d(1,1)*b(1,j)+d(1,2)*b(2,j)+d(1,3)*b(3,j))*fac                eag15920
      d2=(d(2,1)*b(1,j)+d(2,2)*b(2,j)+d(2,3)*b(3,j))*fac                eag15930
      d3=(d(3,1)*b(1,j)+d(3,2)*b(2,j)+d(3,3)*b(3,j))*fac                eag15940
      do 400 i=j,12                                                     eag15950
      qq(i,j)=qq(i,j)+b(1,i)*d1+b(2,i)*d2+b(3,i)*d3                     eag15960
 400  qq(j,i)=qq(i,j)                                                   eag15970
c                                                                       eag15980
c     form equivalent body force vector                                 eag15990
c                                                                       eag16000
      if (igrav.eq.0) go to 500                                         eag16010
      bz=fz*xj                                                          eag16020
      p(2)=p(2)+bz*h1/4.                                                eag16030
      p(4)=p(4)+bz*h2/4.                                                eag16040
      p(6)=p(6)+bz*h3/4.                                                eag16050
      p(8)=p(8)+bz*h4/4.                                                eag16060
  500 continue                                                          eag16070
c                                                                       eag16080
c     eliminate auxiliary degrees of freedom                            eag16090
c                                                                       eag16100
      if((d(3,3).lt.d(1,1)/1000000.).or.triang) go to 80                eag16110
      do 50 n=1,4                                                       eag16120
      l=12-n                                                            eag16130
      m=l+1                                                             eag16140
      do 50 i=1,l                                                       eag16150
      c=qq(i,m)/qq(m,m)                                                 eag16160
      do 50 j=1,l                                                       eag16170
   50 qq(i,j)=qq(i,j)-c*qq(m,j)                                         eag16180
c                                                                       eag16190
c     relocate the stiffness matrix and load vector                     eag16200
c                                                                       eag16210
   80 do 70 i=1,8                                                       eag16220
      q(i)=p(i)                                                         eag16230
      do 70 j=1,8                                                       eag16240
   70 qk(i,j)=qq(i,j)                                                   eag16250
c                                                                       eag16260
c     form stress matrix qs at centroid (rm,zm) of the element          eag16270
c                                                                       eag16280
      do 40 i=1,3                                                       eag16290
      d1=d(i,1)                                                         eag16300
      d2=d(i,2)                                                         eag16310
      d3=d(i,3)                                                         eag16320
      t1=( d1*z24-d3*r24)/vol                                           eag16330
      t2=(-d1*z13+d3*r13)/vol                                           eag16340
      t3=(-d2*r24+d3*z24)/vol                                           eag16350
      t4=( d2*r13-d3*z13)/vol                                           eag16360
      qc(i,1)=   t1                                                     eag16370
      qc(i,3)=   t2                                                     eag16380
      qc(i,5)=  -t1                                                     eag16390
      qc(i,7)=  -t2                                                     eag16400
      qc(i,2)= t3                                                       eag16410
      qc(i,4)= t4                                                       eag16420
      qc(i,6)=-t3                                                       eag16430
      qc(i,8)=-t4                                                       eag16440
   40 continue                                                          eag16450
c                                                                       eag16460
c     compute lumped masses                                             eag16470
c                                                                       eag16480
      rm1=r1-rm                                                         eag16490
      rm2=r2-rm                                                         eag16500
      rm3=r3-rm                                                         eag16510
      rm4=r4-rm                                                         eag16520
      zm1=z1-zm                                                         eag16530
      zm2=z2-zm                                                         eag16540
      zm3=z3-zm                                                         eag16550
      zm4=z4-zm                                                         eag16560
      elmass(1)=rho*( rm1*z24-zm1*r24)/4.                               eag16570
      elmass(2)=rho*(-rm2*z13+zm2*r13)/4.                               eag16580
      elmass(3)=rho*(-rm3*z24+zm3*r24)/4.                               eag16590
      elmass(4)=rho*( rm4*z13-zm4*r13)/4.                               eag16600
c                                                                       eag16610
      return                                                            eag16620
      end                                                               eag16630
      subroutine  readb (a,la,n,numel)                                  eag16640
c                                                                       eag16650
c     ******************************************************************eag16660
c     read element data from tape                                       eag16670
c     ******************************************************************eag16680
c                                                                       eag16690
      implicit real*8 (a-h,o-z)                                         eag16700
      common /buf/ b(2220)                                              eag16710
      dimension a(la)                                                   eag16720
c                                                                       eag16730
      lb=2220                                                           eag16740
      if ( n .ne. 1 ) go to 100                                         eag16750
      rewind 1                                                          eag16760
      m=0                                                               eag16770
      read (1) b                                                        eag16780
  100 mm=m+la                                                           eag16790
      do 200 i=1,la                                                     eag16800
      ii=i+m                                                            eag16810
  200 a(i)=b(ii)                                                        eag16820
      m=mm                                                              eag16830
      if ( n .eq. numel ) go to 400                                     eag16840
      if ( (m+la) .le. lb ) go to 400                                   eag16850
      read (1) b                                                        eag16860
      m=0                                                               eag16870
  400 return                                                            eag16880
      end                                                               eag16890
      subroutine readss (sst,xy,llm,numel)                              eag16900
c                                                                       eag16910
c     ******************************************************************eag16920
c     subroutine to read element stress transformation matrices,        eag16930
c     centroidal coordinates and lm array from tape 1 and store         eag16940
c     them in core as one-dimension arrays                              eag16950
c     ******************************************************************eag16960
c                                                                       eag16970
      implicit real*8 (a-h,o-z)                                         eag16980
      dimension sst(1),xy(1),llm(1)                                     eag16990
      common /eldata/ lm(8),ss(3,8),xc,yc,elmass(4),s(8,8),q(8),c(3,3), eag17000
     .                mtype,mjunk                                       eag17010
c                                                                       eag17020
      rewind 1                                                          eag17030
      k=0                                                               eag17040
      m=0                                                               eag17050
c                                                                       eag17060
      do 120 n=1,numel                                                  eag17070
      call readb(lm,111,n,numel)                                        eag17080
      do 100 i=1,3                                                      eag17090
      do 100 j=1,8                                                      eag17100
      k=k+1                                                             eag17110
  100 sst(k)=ss(i,j)                                                    eag17120
      n2=n+n                                                            eag17130
      xy(n2-1)=xc                                                       eag17140
      xy(n2  )=yc                                                       eag17150
      do 110 j=1,8                                                      eag17160
      m=m+1                                                             eag17170
  110 llm(m)=lm(j)                                                      eag17180
  120 continue                                                          eag17190
      return                                                            eag17200
      end                                                               eag17210
      subroutine ready(y,ln,itape)                                      eag17220
c                                                                       eag17230
c     ******************************************************************eag17240
c     read response data from tape                                      eag17250
c     ******************************************************************eag17260
c                                                                       eag17270
      implicit real*8 (a-h,o-z)                                         eag17280
      dimension y(ln)                                                   eag17290
c                                                                       eag17300
      read (itape) y                                                    eag17310
      return                                                            eag17320
      end                                                               eag17330
      subroutine realy(y,yreal,nc2,nev,itape)                           eag17340
c                                                                       eag17350
c     ******************************************************************eag17360
c     write response of generalized coordinates on tape in blocks       eag17370
c     ******************************************************************eag17380
c                                                                       eag17390
      implicit real*8 (a-h,o-z)                                         eag17400
      common /cntrl2/ ndata,nwr,dt,nrest,nbuf,nblock,ihv,ncomp,isel,    eag17410
     .                icomb,nprint,nd                                   eag17420
      dimension yreal(1),y(nc2,1)                                       eag17430
c                                                                       eag17440
      rewind itape                                                      eag17450
      nrow=2*nwr                                                        eag17460
      nblock=nd   /nrow                                                 eag17470
      if (nblock.eq.0) nrow=nd                                          eag17480
      nb=nrow*nev                                                       eag17490
      nrest=nd   -nblock*nrow                                           eag17500
      jj=0                                                              eag17510
      iblock=0                                                          eag17520
c                                                                       eag17530
  100 iblock=iblock+1                                                   eag17540
      mm=0                                                              eag17550
      do 230 i=1,nrow                                                   eag17560
      jj=jj+1                                                           eag17570
      do 220 kk=1,nev                                                   eag17580
      mm=mm+1                                                           eag17590
  220 yreal(mm)=y(jj,kk)                                                eag17600
  230 continue                                                          eag17610
c                                                                       eag17620
      call writey(yreal,nb,itape)                                       eag17630
c                                                                       eag17640
      if (iblock.lt.nblock) go to 100                                   eag17650
c                                                                       eag17660
      nrow=nrest                                                        eag17670
      nb=nrest*nev                                                      eag17680
      if (iblock.gt.nblock) return                                      eag17690
      if (nrest.gt.0) go to 100                                         eag17700
      return                                                            eag17710
c                                                                       eag17720
      end                                                               eag17730
      subroutine respns(x,xs,a,y,ybuf,sigmax,tmax,sigmin,tmin,node,nelm,eag17740
     .                  stres,sst,xy,llm,nnode,nnelm,neq,nev,nume,num)  eag17750
c                                                                       eag17760
c     ******************************************************************eag17770
c     superposition of modes and time responses of displacements        eag17780
c     and stresses                                                      eag17790
c     ******************************************************************eag17800
c                                                                       eag17810
      implicit real*8 (a-h,o-z)                                         eag17820
      common /cntrl1/ numnp,mband,numel,nbc,igrav,njunk,                eag17830
     .                xjunk(16)                                         eag17840
      common /cntrl2/ ndata,nwr,dt,nrest,nbuf,nblock,ihv,ncomp,isel,    eag17850
     .                icomb,nprint,nd                                   eag17860
      common /label/  hed(10)                                           eag17870
      dimension x(neq),xs(neq),a(neq,nev),y(nev),ybuf(1),sigmax(nume),  eag17880
     .          tmax(1),sigmin(nume),tmin(1),node(1),nelm(1),stres(num),eag17890
     .          sst(1),xy(1),llm(1)                                     eag17900
c                                                                       eag17910
      if (igrav.eq.0.or.icomb.eq.0) go to 100                           eag17920
c                                                                       eag17930
c     read static displacements and stresses from tape                  eag17940
c                                                                       eag17950
      backspace 1                                                       eag17960
      backspace 1                                                       eag17970
      read (1) xs,sigmax,sigmin                                         eag17980
      go to 130                                                         eag17990
c                                                                       eag18000
c     initialize displacements and stresses                             eag18010
c                                                                       eag18020
  100 do 110 i=1,neq                                                    eag18030
  110 xs(i)=0.                                                          eag18040
      do 120 i=1,numel                                                  eag18050
      sigmax(i)=0.                                                      eag18060
  120 sigmin(i)=0.                                                      eag18070
      backspace 1                                                       eag18080
  130 do 140 i=1,numel                                                  eag18090
      tmax(i)=0.                                                        eag18100
  140 tmin(i)=0.                                                        eag18110
c                                                                       eag18120
c     read mode shape matrix from tape                                  eag18130
c                                                                       eag18140
      read (1) a                                                        eag18150
c                                                                       eag18160
c     read element stress transformation matrices                       eag18170
c                                                                       eag18180
      call readss(sst,xy,llm,numel)                                     eag18190
c                                                                       eag18200
      if (isel.eq.0) go to 150                                          eag18210
c                                                                       eag18220
c     read selected nodal point and element numbers for which           eag18230
c     responses are to be printed                                       eag18240
c                                                                       eag18250
      if (nnode.eq.0) go to 145                                         eag18260
      read (5,1000) (node(i),i=1,nnode)                                 eag18270
  145 if (nnelm.eq.0) go to 160                                         eag18280
      read (5,1000) (nelm(i),i=1,nnelm)                                 eag18290
      go to 160                                                         eag18300
  150 nnode=numnp                                                       eag18310
      nnelm=numel                                                       eag18320
c                                                                       eag18330
  160 rewind 2                                                          eag18340
      rewind 3                                                          eag18350
      write (3) numnp,numel,nev,nd,dt                                   eag18360
      nrow=2*nwr                                                        eag18370
      if (nblock.eq.0) nrow=nd                                          eag18380
      nb=nrow*nev                                                       eag18390
      t=0.                                                              eag18400
      iblock=0                                                          eag18410
      iprint=nprint-1                                                   eag18420
      if ((nnode.le.0).and.(nnelm.le.0)) go to 170                      eag18430
      if (icomb.eq.0) write (6,2000) hed                                eag18440
      if (icomb.ne.0) write (6,2001) hed                                eag18450
c                                                                       eag18460
  170 iblock=iblock+1                                                   eag18470
      m=0                                                               eag18480
c                                                                       eag18490
c     read modal responses                                              eag18500
c                                                                       eag18510
      call ready(ybuf,nb,2)                                             eag18520
      do 235 nt=1,nrow                                                  eag18530
      do 180 k=1,nev                                                    eag18540
      m=m+1                                                             eag18550
  180 y(k)=ybuf(m)                                                      eag18560
c                                                                       eag18570
c     superposition of modes                                            eag18580
c                                                                       eag18590
      do 200 n=1,numnp                                                  eag18600
      j=n+n                                                             eag18610
      i=j-1                                                             eag18620
      sum1=0.                                                           eag18630
      sum2=0.                                                           eag18640
      do 190 k=1,nev                                                    eag18650
      sum1=sum1+y(k)*a(i,k)                                             eag18660
  190 sum2=sum2+y(k)*a(j,k)                                             eag18670
      x(i)=sum1+xs(i)                                                   eag18680
  200 x(j)=sum2+xs(j)                                                   eag18690
c                                                                       eag18700
c     write displacements on tape                                       eag18710
c                                                                       eag18720
      write (3) x                                                       eag18730
c                                                                       eag18740
c     print nodal displacements                                         eag18750
c                                                                       eag18760
      iprint=iprint+1                                                   eag18770
      if (iprint.ne.nprint) go to 220                                   eag18780
      if ((nnode.le.0).and.(nnelm.le.0)) go to 205                      eag18790
      write (6,2010) t                                                  eag18800
  205 iprint=0                                                          eag18810
      index=0                                                           eag18820
      if (nnode.le.0) go to 230                                         eag18830
      do 210 i=1,nnode                                                  eag18840
      if (isel.eq.0) n=i                                                eag18850
      if (isel.ne.0) n=node(i)                                          eag18860      
  210 write (6,2020) n,x(n+n-1),x(n+n)                                  eag18870
      go to 230                                                         eag18880
  220 index=1                                                           eag18890
c                                                                       eag18900
c     compute element stresses and print                                eag18910
c                                                                       eag18920
  230 call stress (x,sst,xy,llm,sigmax,tmax,sigmin,tmin,stres,t,nelm,   eag18930
     .             nnelm,isel,num,index)                                eag18940
  235 t=t+dt                                                            eag18950
c                                                                       eag18960
      if (iblock.lt.nblock) go to 170                                   eag18970
      nrow=nrest                                                        eag18980
      nb=nrest*nev                                                      eag18990
      if (iblock.gt.nblock) go to 240                                   eag19000
      if (nrest.gt.0) go to 170                                         eag19010
c                                                                       eag19020
c     print stress envelops                                             eag19030
c                                                                       eag19040
  240 write (6,2030)                                                    eag19050
      write (6,2040) (i,tmax(i),sigmax(i),tmin(i),sigmin(i),i=1,numel)  eag19060
c                                                                       eag19070
      return                                                            eag19080
c                                                                       eag19090
 1000 format (16i5)                                                     eag19100
 2000 format (1h1,20x,10a8//                                            eag19110
     .             95h time response of nodal displacements and element eag19120
     .stresses...not including static effects....../1x,94(1h-)//)       eag19130
 2001 format (1h1,20x,10a8//                                            eag19140
     .             95h time response of nodal displacements and element eag19150
     .stresses...... including static effects....../1x,94(1h-)//)       eag19160
 2010  format (///8h time t=,f10.6,5h sec./1x,22(1h-)//                 eag19170
     . 53h nodal point  x-displacement  y-displacement (in ft.)/)       eag19180
 2020 format (i9,3x,2d16.4)                                             eag19190
 2030 format (90h1 max. and min. stress(psi) in each individual element eag19200
     .and their times(sec) of occurrence //                             eag19210
     . 58h0  element        time  max.stress        time  min.stress //)eag19220
 2040 format (i10,4d12.4)                                               eag19230
      end                                                               eag19240
      subroutine rigid (r,z,xs,ibase,akf0,b,ab,xcg,ycg,bl,numnp,nbase,  eag19250
     .                  nb2)                                            eag19260
c                                                                       eag19270
c     ******************************************************************eag19280
c     calculate forces corresponding to rigid body displacement of      eag19290
c     the base                                                          eag19300
c     ******************************************************************eag19310
c                                                                       eag19320
      implicit real*8 (a-h,o-z)                                         eag19330
      dimension u(3),akr(3,3),r(1),z(1),xs(1),b(nb2,3),ibase(1),        eag19340
     .          ab(nb2,3)                                               eag19350
      complex*16 akf0(nb2,1)                                            eag19360
c                                                                       eag19370
c     resultant forces on the foundation rock                           eag19380
c                                                                       eag19390
      do 100 i=1,3                                                      eag19400
100   u(i)=0.                                                           eag19410
      do 110 i=1,numnp                                                  eag19420
      iy=i+i                                                            eag19430
      ix=iy-1                                                           eag19440
      u(1)=u(1)+xs(ix)                                                  eag19450
      u(2)=u(2)+xs(iy)                                                  eag19460
110   u(3)=u(3)-xs(ix)*(z(i)-ycg)+xs(iy)*(r(i)-xcg)                     eag19470
c                                                                       eag19480
c     displacement transformation matrix b                              eag19490
c                                                                       eag19500
      do 120 i=1,nbase                                                  eag19510
      iy=i+i                                                            eag19520
      ix=iy-1                                                           eag19530
      ii=ibase(iy)/2                                                    eag19540
      b(ix,1)=1.                                                        eag19550
      b(iy,1)=0.                                                        eag19560
      b(ix,2)=0.                                                        eag19570
      b(iy,2)=1.                                                        eag19580
      b(ix,3)=0.                                                        eag19590
      b(iy,3)=(r(ii)-xcg)                                               eag19600
120   continue                                                          eag19610
c                                                                       eag19620
c     calculate rigid body stiffness matrix and store only the upper    eag19630
c     triangle                                                          eag19640
c                                                                       eag19650
      do 140 i=1,nb2                                                    eag19660
      do 140 j=1,3                                                      eag19670
      ab(i,j)=0.                                                        eag19680
      do 130 k=1,nb2                                                    eag19690
130   ab(i,j)=ab(i,j)+dreal(akf0(i,k))*b(k,j)                           eag19700
140   continue                                                          eag19710
c                                                                       eag19720
      do 150 i=1,3                                                      eag19730
      do 150 j=1,3                                                      eag19740
150   akr(i,j)=0.                                                       eag19750
      do 170 i=1,3                                                      eag19760
      do 170 j=i,3                                                      eag19770
      l=j-i+1                                                           eag19780
      do 160 k=1,nb2                                                    eag19790
160   akr(i,l)=akr(i,l)+b(k,i)*ab(k,j)                                  eag19800
170   continue                                                          eag19810
c                                                                       eag19820
c     solve for rigid body displacements                                eag19830
c                                                                       eag19840
      call bansol (3,3,3,akr,u,0)                                       eag19850
      call bansol (3,3,3,akr,u,1)                                       eag19860
c                                                                       eag19870
c     calculate r0 and add to load vector                               eag19880
c                                                                       eag19890
      do 190 i=1,nb2                                                    eag19900
      r0=0.                                                             eag19910
      l=ibase(i)                                                        eag19920
      do 180 j=1,3                                                      eag19930
180   r0=r0+ab(i,j)*u(j)                                                eag19940
190   xs(l)=xs(l)-r0                                                    eag19950
c                                                                       eag19960
      return                                                            eag19970
      end                                                               eag19980
      subroutine static (nebc,xs,a,sigmax,tmax,sigmin,tmin,stres,       eag19990
     .                   sst,xy,llm,neq,mban,num,nume)                  eag20000
c                                                                       eag20010
c     ******************************************************************eag20020
c     compute static response                                           eag20030
c     ******************************************************************eag20040
c                                                                       eag20050
      implicit real*8 (a-h,o-z)                                         eag20060
      common /cntrl1/ numnp,mband,numel,nbc,xjunk(17)                   eag20070
      common /label/  hed(10)                                           eag20080
      dimension nebc(1),xs(neq),a(neq,mban ),sigmax(nume),tmax(1),      eag20090
     .          sigmin(nume),tmin(1),stres(1),sst(1),xy(1),llm(1)       eag20100
c                                                                       eag20110
      call bansol(neq,mband,neq,a,xs,0)                                 eag20120
      call bansol(neq,mband,neq,a,xs,1)                                 eag20130
c                                                                       eag20140
      write (6,2009) hed                                                eag20150
      write (6,2010) (n,xs(2*n-1),xs(2*n),n=1,numnp)                    eag20160
      tt=0.0                                                            eag20170
      do 100 n=1,numel                                                  eag20180
      sigmax(n)=-99999.                                                 eag20190
      tmax(n)=0.                                                        eag20200
      sigmin(n)=99999.                                                  eag20210
  100 tmin(n) =0.                                                       eag20220
c                                                                       eag20230
      call readss(sst,xy,llm,numel)                                     eag20240
c                                                                       eag20250
      write (6,2020) hed                                                eag20260
      call stress (xs,sst,xy,llm,sigmax,tmax,sigmin,tmin,stres,tt,nelm, eag20270
     .             numel,0,num,0)                                       eag20280
c                                                                       eag20290
      read (1)                                                          eag20300
      write (1) xs,sigmax,sigmin                                        eag20310
      return                                                            eag20320
c                                                                       eag20330
 2009 format (1h1,                                                      eag20340
     . 20x,10a8//1x,23(1h*)/24h static analysis results/1x,23(1h*)///   eag20350
     . 42h displacements due to static loads...in ft  /                 eag20360
     . 42h ----------------------------------------- //                 eag20370
     . 42h nodal pt  x-displacement  y-displacement  )                  eag20380
 2010 format(i9,2d16.4)                                                 eag20390
 2020 format (1h1,20x,10a8)                                             eag20400
      end                                                               eag20410
      subroutine stiff (r,z,nebc,code,ymod,enu,ro,nummat,psp)           eag20420
c                                                                       eag20430
c     ******************************************************************eag20440
c     geometry of the structure and material properties are read in.    eag20450
c     nodal points can be generated at equal intervals or in layers.    eag20460
c     element stiffness,mass etc. are written on tape 1 element         eag20470
c     by element.                                                       eag20480
c     ******************************************************************eag20490
c                                                                       eag20500
      implicit real*8 (a-h,o-z)                                         eag20510
      common /cntrl1/ numnp,mband,numel,nbc,igrav,njunk,xjunk(16)       eag20520
      common /eldata/ lm(8),ss(3,8),xc,yc,elmass(4),s(8,8),q(8),c(3,3), eag20530
     .                mtype,mjunk                                       eag20540
      common /label/  hed(10)                                           eag20550
      dimension r(1),z(1),nebc(1),code(1),ix(4),ie(5),ymod(1),enu(1),   eag20560
     .          ro(1)                                                   eag20570
c                                                                       eag20580
c     read and print material properties                                eag20590
c                                                                       eag20600
      write (6,2000) hed                                                eag20610
      do 110 m=1,nummat                                                 eag20620
      read  (5,1001) mtype,ymod(mtype),enu(mtype),ro(mtype)             eag20630
      write (6,2006) mtype,ymod(mtype),enu(mtype),ro(mtype)             eag20640
      if (enu(mtype).lt.0.4999) go to 105                               eag20650
      enu(mtype)=1.                                                     eag20660
      f=ymod(mtype)                                                     eag20670
      go to 110                                                         eag20680
  105 if (psp.eq.0.0) go to 110                                         eag20690
      ymod(mtype)=ymod(mtype)/(1.-enu(mtype)**2)                        eag20700
      enu(mtype) =enu(mtype)/(1.-enu(mtype))                            eag20710
  110 continue                                                          eag20720
c                                                                       eag20730
c     read and print of nodal point data                                eag20740
c                                                                       eag20750
      write (6,2004) hed                                                eag20760
      l=0                                                               eag20770
      nbc=0                                                             eag20780
  120 read  (5,1002) n,code(n),r(n),z(n),mod,nlim,facr,facz             eag20790
      l1=l+1                                                            eag20800
      if (n-l1) 190,170,130                                             eag20810
  130 if (l.le.0) go to 180                                             eag20820
      div=n-l                                                           eag20830
      dr=(r(n)-r(l))/div                                                eag20840
      dz=(z(n)-z(l))/div                                                eag20850
      m=n-1                                                             eag20860
      do 140 k=l1,m                                                     eag20870
      code(k)=0.0                                                       eag20880
      r(k)=r(k-1)+dr                                                    eag20890
  140 z(k)=z(k-1)+dz                                                    eag20900
      go to 170                                                         eag20910
  150 l1=n+1                                                            eag20920
      if (facr.le.0.0) facr=1.0                                         eag20930
      if (facz.le.0.0) facz=1.0                                         eag20940
      write (6,2100) mod,nlim,facr,facz                                 eag20950
  160 n=n+1                                                             eag20960
      n1=n-mod                                                          eag20970
      n2=n1-mod                                                         eag20980
      if (n1.le.0.or.n2.le.0) go to 200                                 eag20990
      code(n)=0.0                                                       eag21000
      r(n)=r(n1)+facr*(r(n1)-r(n2))                                     eag21010
      z(n)=z(n1)+facz*(z(n1)-z(n2))                                     eag21020
      if (n.lt.nlim) go to 160                                          eag21030
      mod=0                                                             eag21040
  170 l=n                                                               eag21050
      write (6,2002)(k,code(k),r(k),z(k),k=l1,n)                        eag21060
      cod=code(n)                                                       eag21070
      if ((cod.eq.1.0).or.(cod.eq.3.0)) go to 171                       eag21080
      go to 172                                                         eag21090
  171 nbc=nbc+1                                                         eag21100
      nebc(nbc)=2*n-1                                                   eag21110
  172 if ((cod.eq.2.0).or.(cod.eq.3.0)) go to 173                       eag21120
      go to 175                                                         eag21130
  173 nbc=nbc+1                                                         eag21140
      nebc(nbc)=2*n                                                     eag21150
  175 if (mod.gt.0) go to 150                                           eag21160
      if (n-numnp) 120,220,210                                          eag21170
  180 write (6,2130)                                                    eag21180
      stop                                                              eag21190
  190 write (6,2140) n                                                  eag21200
      stop                                                              eag21210
  200 write (6,2150)                                                    eag21220
      stop                                                              eag21230
  210 write (6,2160) n,numnp                                            eag21240
      stop                                                              eag21250
  220 continue                                                          eag21260
c                                                                       eag21270
c     read and print element properties                                 eag21280
c                                                                       eag21290
      write (6,2001) hed                                                eag21300
      n=0                                                               eag21310
      mband=0                                                           eag21320
  230 read(5,1003) m,(ie(i),i=1,5)                                      eag21330
  240 n=n+1                                                             eag21340
      if(m.eq.n) go to 260                                              eag21350
      do 250 i=1,4                                                      eag21360
  250 ix(i)=ix(i)+1                                                     eag21370
      go to 280                                                         eag21380
  260 do 270 i=1,4                                                      eag21390
  270 ix(i)=ie(i)                                                       eag21400
      mtype=ie(5)                                                       eag21410
c                                                                       eag21420
c     determine band width                                              eag21430
c                                                                       eag21440
  280 mb=0                                                              eag21450
      do 290 i=1,4                                                      eag21460
      do 290 j=1,4                                                      eag21470
      mm=iabs(ix(i)-ix(j))                                              eag21480
      if(mm.gt.mb) mb=mm                                                eag21490
  290 continue                                                          eag21500
      mb=2*mb+2                                                         eag21510
      if(mb.gt.mband) mband=mb                                          eag21520
      write (6,2003) n,(ix(i),i=1,4),mtype                              eag21530
c                                                                       eag21540
c     stress-strain transformation matrix                               eag21550
c                                                                       eag21560
      if (enu(mtype).le.0.999) go to 300                                eag21570
      go to 305                                                         eag21580
  300 f=ymod(mtype)/(1.-enu(mtype)**2)                                  eag21590
  305 c(1,1)=f                                                          eag21600
      c(1,2)=f*enu(mtype)                                               eag21610
      c(1,3)=0.0                                                        eag21620
      c(2,1)=c(1,2)                                                     eag21630
      c(2,2)=c(1,1)                                                     eag21640
      c(2,3)=0.0                                                        eag21650
      c(3,1)=0.0                                                        eag21660
      c(3,2)=0.0                                                        eag21670
      c(3,3)=0.5*f*(1.-enu(mtype))                                      eag21680
c                                                                       eag21690
c     form element stiffness matrices                                   eag21700
c                                                                       eag21710
      i=ix(1)                                                           eag21720
      j=ix(2)                                                           eag21730
      k=ix(3)                                                           eag21740
      l=ix(4)                                                           eag21750
      rho=ro(mtype)                                                     eag21760
      call quad (r(i),r(j),r(k),r(l),z(i),z(j),z(k),z(l),xc,yc,elmass,  eag21770
     .           c,s,ss,q,rho,igrav)                                    eag21780
c      write(6,309) n,elmass                                            eag21790
c  309 format(10x,i5,4d13.6)                                            eag21800  
c                                                                       eag21810
      do 310 i=1,4                                                      eag21820
      ik=i+i                                                            eag21830
      ii=ix(i)                                                          eag21840
      ij=ii+ii                                                          eag21850
      lm(ik)=ij                                                         eag21860
      lm(ik-1)=ij-1                                                     eag21870
  310 continue                                                          eag21880
c     store element information on tape                                 eag21920
c                                                                       eag21930
      call writeb(lm,111,n,numel)                                       eag21940
      if(n.eq.numel) go to 320                                          eag21950
      if(n.eq.m) go to 230                                              eag21960
      go to 240                                                         eag21970
  320 return                                                            eag21980
c                                                                       eag21990
 1001 format (i5,3f10.0)                                                eag22000
 1002 format (i5,f5.0,2f10.0,2i5,2f10.0)                                eag22010
 1003 format (6i5)                                                      eag22020
 2000 format (1h1,                                                      eag22030
     . 20x,10a8//1x,20(1h*)/21h material information/1x,20(1h*)/)       eag22040
 2001 format (1h1,                                                      eag22050
     . 20x,10a8//1x,21(1h*)/22h element specification/1x,21(1h*)//      eag22060
     . 54h element no.      i     j     k     l         material  //)   eag22070
 2002 format (i7, f10.2,2f10.3)                                         eag22080
 2003 format (i11,2x,4i6,i12)                                           eag22090
 2004 format (1h1,                                                      eag22100
     . 20x,10a8//1x,25(1h*)/26h nodal point specification/1x,25(1h*)/// eag22110
     . 37h   node      code     x-ord     y-ord  /)                     eag22120
 2006 format (16h0material number i3/                                   eag22130
     . 4h0 e= f16.6,7h k/sft./                                          eag22140
     . 4h0nu= f16.6/                                                    eag22150
     . 4h0ro= f16.6,16h k-sec**2/ft.**4/)                               eag22160
 2100 format (21h generation with mod=i3,3x,6h nlim=i4,3x,6h facr=f10.5,eag22170
     . 3x,6h facz=f10.5)                                                eag22180
 2130 format (28h0first joint card is missing)                          eag22190
 2140 format (31h0coordinate card for joint no. i5,16h not in sequence) eag22200
 2150 format (42h0insufficient information to generate mesh)            eag22210
 2160 format (14h0joint number i5,21h exceeds given numnp=i5)           eag22220
      end                                                               eag22230
      subroutine stress (x0,sst,xy,llm,sigmax,tmax,sigmin,tmin,stres,tt,eag22240
     .                   nelm,nnelm,isel,num,index)                     eag22250
c                                                                       eag22260
c     ******************************************************************eag22270
c     compute element stresses and stress envelopes                     eag22280
c     ******************************************************************eag22290
c                                                                       eag22300
      implicit real*8 (a-h,o-z)                                         eag22310
      common /cntrl1/ numnp,mband,numel,njunk,xjunk(17)                 eag22320
      dimension x0(1),sig(6),sigmax(1),tmax(1),sigmin(1),tmin(1),       eag22330
     .          nelm(1),stres(num),sst(1),xy(1),llm(1)                  eag22340
c                                                                       eag22350
c     compute element stresses                                          eag22360
c                                                                       eag22370
      if ((index.eq.0).and.(nnelm.gt.0)) write (6,2000)                 eag22380
      k=1                                                               eag22390
      ii=0                                                              eag22400
c                                                                       eag22410
      do 300 n=1,numel                                                  eag22420
      n2=n+n                                                            eag22430
      n8=(n-1)*8                                                        eag22440
c                                                                       eag22450
      do 180 i=1,3                                                      eag22460
      sig(i)=0.0                                                        eag22470
      do 180 j=1,8                                                      eag22480
      ii=ii+1                                                           eag22490
      m=n8+j                                                            eag22500
      jj=llm(m)                                                         eag22510
  180 sig(i)=sig(i)+sst(ii)*x0(jj)                                      eag22520
      do 190 j=1,3                                                      eag22530
  190 sig(j)=6.94444*sig(j)                                             eag22540
      nn=3*n                                                            eag22550
      stres(nn-2)=sig(1)                                                eag22560
      stres(nn-1)=sig(2)                                                eag22570
      stres(nn)  =sig(3)                                                eag22580
c                                                                       eag22590
      xc=xy(n2-1)                                                       eag22600
      yc=xy(n2  )                                                       eag22610
c                                                                       eag22620
c     calculate principal stresses                                      eag22630
c                                                                       eag22640
      cc=(sig(1)+sig(2))/2.0                                            eag22650
      bb=(sig(1)-sig(2))/2.                                             eag22660
      cr=dsqrt(bb**2+sig(3)**2)                                         eag22670
      sig(4)=cc+cr                                                      eag22680
      sig(5)=cc-cr                                                      eag22690
      if ((bb.eq.0.0).and.(sig(3).eq.0.0)) go to 255                    eag22700
      sig(6)=28.648*datan2(sig(3),bb)                                   eag22710
c                                                                       eag22720
  255 if ((index.ne.0).or.(nnelm.eq.0)) go to 330                       eag22730
      if (isel.eq.0) go to 310                                          eag22740
      if (k.gt.nnelm) go to 330                                         eag22750
      if (n.ne.nelm(k)) go to 330                                       eag22760
  310 write (6,2001) n,xc,yc,(sig(i),i=1,6)                             eag22770
      k=k+1                                                             eag22780
c                                                                       eag22790
  330 if (sigmax(n)-sig(4)) 340,350,350                                 eag22800
  340 sigmax(n)=sig(4)                                                  eag22810
      tmax(n)=tt                                                        eag22820
  350 if (sigmin(n)-sig(5)) 300,300,360                                 eag22830
  360 sigmin(n)=sig(5)                                                  eag22840
      tmin(n)=tt                                                        eag22850
  300 continue                                                          eag22860
      write (3) stres                                                   eag22870
      return                                                            eag22880
c                                                                       eag22890
 2000 format(/1h0,23helement stresses in psi/                           eag22900
     .6h0el.no  7x  1hx  7x  1hy  7x  5hsig#x  7x  5hsig#y  6x  6htau#xyeag22910
     .5x  7hsig#max  5x  7hsig#min  5x  5hangle /)                      eag22920
 2001 format (i5,1x,2f8.2,5d12.4,f10.2)                                 eag22930
      end                                                               eag22940
      subroutine total(r,z,nebc,ijbc,rmass,akf0,ibase,a,xs,b,ab,neq,    eag22950
     .                 mban,sgn,nb2,escale)                             eag22960
c                                                                       eag22970
c     ******************************************************************eag22980
c     total stiffness and mass matrices and load vector are formed by   eag22990
c     reading the element stiffness and mass etc.from tape 1.nodal pointeag23000
c     loads due to water pressure are calculated.                       eag23010
c     ******************************************************************eag23020
c                                                                       eag23030
      implicit real*8 (a-h,o-z)                                         eag23040
      common /cntrl1/ numnp,mband,numel,nbc,igrav,npp,wl,trace,         eag23050
     .                iopr,iopp,nbase,irig,xjunk(12)                    eag23060
      common /eldata/ lm(8),ss(3,8),xc,yc,elmass(4),s(8,8),q(8),c(3,3), eag23070
     .                mtype,mjunk                                       eag23080
      common /label/  hed(10)                                           eag23090
      dimension r(1),z(1),nebc(1),rmass(1),xs(1),a(neq,mban),ijbc(1),   eag23100
     .          ibase(1),b(nb2,3),ab(nb2,3)                             eag23110
      complex*16 akf0(nb2,nb2)                                          eag23120
c                                                                       eag23130
c     form total mass and stiffness matrices                            eag23140
c                                                                       eag23150
      do 100 i=1,neq                                                    eag23160
      rmass(i)=0.0                                                      eag23170
      xs(i)=0.0                                                         eag23180
      do 100 j=1,mband                                                  eag23190
  100 a(i,j)=0.0                                                        eag23200
      do 140 n=1,numel                                                  eag23210
c                                                                       eag23220
      call readb(lm,111,n,numel)                                        eag23230
c                                                                       eag23260
      do 120 i=1,8                                                      eag23270
      ii=lm(i)                                                          eag23280
      xs(ii)=xs(ii)+q(i)                                                eag23290
      do 110 j=1,8                                                      eag23300
      jj=lm(j)-ii+1                                                     eag23310
      if (jj.lt.1) go to 110                                            eag23320
      a(ii,jj)=a(ii,jj)+s(i,j)                                          eag23330
  110 continue                                                          eag23340
  120 continue                                                          eag23350
      do 130 i=1,4                                                      eag23360
      ii=lm(2*i)                                                        eag23370
      rmass(ii)=rmass(ii)+elmass(i)                                     eag23380
  130 rmass(ii-1)=rmass(ii)                                             eag23390
  140 continue                                                          eag23400
      write (1) a                                                       eag23430
c                                                                       eag23440
c     pressure boundary conditions                                      eag23450
c                                                                       eag23460
      if(npp.eq.0) go to 160                                            eag23470
      read  (5,1010) lr,(ijbc(k),k=1,npp)                               eag23480
      if (lr.eq.0) write (6,2010)hed                                    eag23490
      if (lr.ne.0) write (6,2011)hed                                    eag23500
      write (6,2020)                                                    eag23510
      i=ijbc(1)                                                         eag23520
      j=ijbc(2)                                                         eag23530
      ii=i+i                                                            eag23540
      jj=j+j                                                            eag23550
      x=wl-z(j)                                                         eag23560
      pj=0.0624*x                                                       eag23570
      dz=z(i)-z(j)                                                      eag23580
      dr=r(i)-r(j)                                                      eag23590
      sgn=1.                                                            eag23600
      if (lr.ne.0) sgn=-sgn                                             eag23610
      pj=pj*sgn                                                         eag23620
      x1=wl-z(i)                                                        eag23630
      if (x1.le.0.) go to 200                                           eag23640
      pj=0.0624*x1                                                      eag23650
      pj=pj*sgn                                                         eag23660
      r1=0.                                                             eag23670
      r2=0.                                                             eag23680
      nf=1                                                              eag23690
      go to 210                                                         eag23700
  200 f=x/dz                                                            eag23710
      ri1= pj*f**2.*dz/6.                                               eag23720
      ri2=-pj*f**2.*dr/6.                                               eag23730
      rj1= pj*f*(1-f/3.)*dz/2.                                          eag23740
      rj2=-pj*f*(1-f/3.)*dr/2.                                          eag23750
      xs(ii-1)=xs(ii-1)+ri1                                             eag23760
      xs(ii)=xs(ii)+ri2                                                 eag23770
      xs(jj-1)=xs(jj-1)+rj1                                             eag23780
      xs(jj)=xs(jj)+rj2                                                 eag23790
      r1=rj1                                                            eag23800
      r2=rj2                                                            eag23810
      write (6,2030) i,ri1,ri2                                          eag23820
      nf=2                                                              eag23830
  210 nn=npp-1                                                          eag23840
      do 150 l=nf,nn                                                    eag23850
      pi=pj                                                             eag23860
      i=ijbc(l)                                                         eag23870
      j=ijbc(l+1)                                                       eag23880
      ii=i+i                                                            eag23890
      jj=j+j                                                            eag23900
      dr=r(i)-r(j)                                                      eag23910
      dz=z(i)-z(j)                                                      eag23920
      pj=0.0624*(wl-z(j))                                               eag23930
      pj=pj*sgn                                                         eag23940
      ri1= (2.*pi+pj)*dz/6.                                             eag23950
      ri2=-(2.*pi+pj)*dr/6.                                             eag23960
      rj1= (2.*pj+pi)*dz/6.                                             eag23970
      rj2=-(2.*pj+pi)*dr/6.                                             eag23980
      xs(ii-1)=xs(ii-1)+ri1                                             eag23990
      xs(ii)=xs(ii)+ri2                                                 eag24000
      xs(jj-1)=xs(jj-1)+rj1                                             eag24010
      xs(jj)=xs(jj)+rj2                                                 eag24020
      ri1=ri1+r1                                                        eag24030
      ri2=ri2+r2                                                        eag24040
      r1=rj1                                                            eag24050
      r2=rj2                                                            eag24060
      write (6,2030) i,ri1,ri2                                          eag24070
  150 continue                                                          eag24080
      write (6,2030) j,r1,r2                                            eag24090
  160 continue                                                          eag24100
c                                                                       eag24110
c     add static foundation stiffness and equivalent forces             eag24120
c     for rigid body motion of flexible foundation rock                 eag24130
c                                                                       eag24140
      if(irig.ne.0) go to 250                                           eag24150
c                                                                       eag24160
c     form static foundation rock stiffnes                              eag24170
c                                                                       eag24180
      rewind 90                                                         eag24190
      read(90)                                                          eag24200
      read(90)                                                          eag24210
      read(90) akf0                                                     eag24220
      rewind 90                                                         eag24230
      do 220 i=1,nb2                                                    eag24240
      do 220 j=i,nb2                                                    eag24250
      akf0(i,j)=akf0(i,j)*escale                                        eag24260
220   akf0(j,i)=akf0(i,j)                                               eag24270
c                                                                       eag24280
c     read base node numbers                                            eag24290
c                                                                       eag24300
c     coordinates of centroid of base                                   eag24310
c                                                                       eag24320
      read(5,1010)(ibase(i),i=1,nb2,2)                                  eag24330
      il=ibase(1)                                                       eag24340
      ir=ibase(nb2-1)                                                   eag24350
      bl=(r(ir)-r(il))/2.                                               eag24360
      xcg=(r(ir)+r(il))/2.                                              eag24370
      ycg=(z(ir)+z(il))/2.                                              eag24380
c                                                                       eag24390
c     equation numbers corresponding to base dof.                       eag24400
c                                                                       eag24410
      do 230 i=1,nbase                                                  eag24420
      ii=i+i                                                            eag24430
      j=ibase(ii-1)                                                     eag24440
      ibase(ii)=2*j                                                     eag24450
230   ibase(ii-1)=ibase(ii)-1                                           eag24460
c                                                                       eag24470
c     add foundation static stiffness to structure stiffness            eag24480
c                                                                       eag24490
      do 240 i=1,nb2                                                    eag24500
      l=ibase(i)                                                        eag24510
      do 240 j=1,nb2                                                    eag24520
      k=ibase(j)-l+1                                                    eag24530
      if((k.le.0) .or. (k.gt.mband)) go to 240                          eag24540
      a(l,k)=a(l,k)+dreal(akf0(i,j))                                    eag24550
240   continue                                                          eag24560
c                                                                       eag24570
c     compute r0 and add to xs                                          eag24580
c                                                                       eag24590
      call rigid (r,z,xs,ibase,akf0,b,ab,xcg,ycg,bl,numnp,nbase,nb2)    eag24600
250   continue                                                          eag24610
c                                                                       eag24620
c     displacement boundary conditions                                  eag24630
c                                                                       eag24640
      trace=0.                                                          eag24650
      do 170 i=1,neq                                                    eag24660
  170 trace=trace+dabs(a(i,1))                                          eag24670
      if (nbc.le.0) go to 190                                           eag24680
      do 180 k=1,nbc                                                    eag24690
      i=nebc(k)                                                         eag24700
      a(i,1)=1.0                                                        eag24710
      xs(i)=0.                                                          eag24720
      do 180 j=2,mband                                                  eag24730
      a(i,j)=0.                                                         eag24740
      l=i-j+1                                                           eag24750
      if (l.le.0) go to 180                                             eag24760
      a(l,j)=0.                                                         eag24770
  180 continue                                                          eag24780
  190 return                                                            eag24790
c                                                                       eag24800
 1010 format (16i5)                                                     eag24810
 2010 format (1h1,                                                      eag24820
     . 20x,10a8// 46h positive x-direction is downstream  ---------///) eag24830
 2011 format (1h1,                                                      eag24840
     . 20x,10a8// 46h positive x-direction is upstream ------------///) eag24850
 2020 format (52h equivalent nodal forces due to hydrostatic pressure //eag24860
     .32h nodal point    x-load    y-load/)                             eag24870
 2030 format (i12,2f10.3)                                               eag24880
      end                                                               eag24890
      subroutine trnfrm (y,ug,ybuf,xt,xug,nexp,nc,nev,td,nxugh,nxugv)   eag24900
c                                                                       eag24910
c     ******************************************************************eag24920
c     transform frequency response functions to time domain with fft    eag24930
c     for specified free-field ground acceleration                      eag24940
c     ******************************************************************eag24950
c                                                                       eag24960
      implicit real*8 (a-h,o-z)                                         eag24970
      common /cntrl2/ ndata,nwr,dt,nrest,nbuf,nblock,ihv,ncomp,isel,    eag24980
     .                icomb,nprint,nd                                   eag24990
      complex*16 ybuf(1),ug(1),y(nc,1)                                  eag25000
      dimension xt(1),xug(1)                                            eag25010
c                                                                       eag25020
      fac=32.2                                                          eag25030
      nb=2*nbuf                                                         eag25040
      nn=2*ndata                                                        eag25050
      n2=nn+2                                                           eag25060
      delf=1.0/(dble(float(nn))*dt)                                     eag25070
c                                                                       eag25080
c     transform response to each ground motion component                eag25090
c                                                                       eag25100
      do 400 i=1,ncomp                                                  eag25110
c                                                                       eag25120
c     read free-field ground acceleration data                          eag25130
c                                                                       eag25140
      itape=2                                                           eag25150
      if (i.eq.2) go to 50                                              eag25160
      if (ihv-1) 40,60,40                                               eag25170
   40 read  (5,1000) (xt(k),xug(k),k=1,nxugh)                           eag25180
      write (6,2000) (xt(k),xug(k),k=1,nxugh)                           eag25190
      nx=nxugh                                                          eag25200
      go to 70                                                          eag25210
   50 itape=3                                                           eag25220
   60 read  (5,1000) (xt(k),xug(k),k=1,nxugv)                           eag25230
      write (6,2001) (xt(k),xug(k),k=1,nxugv)                           eag25240
      nx=nxugv                                                          eag25250
   70 do 140 k=1,nx                                                     eag25260
  140 xug(k)=xug(k)*fac                                                 eag25270
c                                                                       eag25280
c     interpolate ground motion data at dt steps                        eag25290
c                                                                       eag25300
      do 150 k=1,ndata                                                  eag25310
  150 ug(k)=0.                                                          eag25320
      nd=(td/dt+.5)+1                                                   eag25330
      if (nd.gt.ndata) nd=ndata                                         eag25340
      call cinter (xt,xug,nx,nd,dt,ug)                                  eag25350
c                                                                       eag25360
c     fourier transform of earthquake ground motion                     eag25370
c                                                                       eag25380
      call fft (ug,nexp,2,0,0,dt)                                       eag25390
c                                                                       eag25400
c     read complex frequency response from tape and                     eag25410
c     store as 2-dimensional array                                      eag25420
c                                                                       eag25430
      rewind itape                                                      eag25440
      jj=0                                                              eag25450
      do 110 n=1,nblock                                                 eag25460
      mm=0                                                              eag25470
      call ready(ybuf,nb,itape)                                         eag25480
      do 100 ll=1,nwr                                                   eag25490
      jj=jj+1                                                           eag25500
      do 100 kk=1,nev                                                   eag25510
      mm=mm+1                                                           eag25520
  100 y(jj,kk)=ybuf(mm)                                                 eag25530
  110 continue                                                          eag25540
      if (nrest.eq.0) go to 130                                         eag25550
      nr=2*nrest*nev                                                    eag25560
      call ready(ybuf,nr,itape)                                         eag25570
      mm=0                                                              eag25580
      do 120 ll=1,nrest                                                 eag25590
      jj=jj+1                                                           eag25600
      do 120 kk=1,nev                                                   eag25610
      mm=mm+1                                                           eag25620
  120 y(jj,kk)=ybuf(mm)                                                 eag25630
  130 continue                                                          eag25640
c                                                                       eag25650
c     form y(w)*ug(w)                                                   eag25660
c                                                                       eag25670
      do 160 k=1,nev                                                    eag25680
      y(1,k)=dcmplx(dreal(y(1,k))*dreal(ug(1)),                         eag25690
     .            dreal(y(nc,k))*dimag(ug(1)))                          eag25700
      do 160 j=2,ndata                                                  eag25710
  160 y(j,k)=y(j,k)*ug(j)                                               eag25720
c                                                                       eag25730
c     write array y on tape                                             eag25740
c                                                                       eag25750
      rewind itape                                                      eag25760
      do 170 k=1,nev                                                    eag25770
  170 call writey(y(1,k),n2,itape)                                      eag25780
  400 continue                                                          eag25790
c                                                                       eag25800
c     inverse fourier transform to time domain                          eag25810
c                                                                       eag25820
      rewind 2                                                          eag25830
      rewind 3                                                          eag25840
      iev=0                                                             eag25850
  190 iev=iev+1                                                         eag25860
      iev1=iev+1                                                        eag25870
      call ready(y(1,iev),n2,2)                                         eag25880
      if (ihv.ne.2) go to 200                                           eag25890
      call ready(y(1,iev1),n2,3)                                        eag25900
      do 195 j=1,ndata                                                  eag25910
  195 y(j,iev)=y(j,iev)+y(j,iev1)                                       eag25920
c                                                                       eag25930
  200 call fft (y(1,iev),nexp,2,0,1,delf)                               eag25940
      if (iev.lt.nev) go to 190                                         eag25950
      call realy(y,ybuf,2*nc,nev,2)                                     eag25960
      return                                                            eag25970
c                                                                       eag25980
 1000 format (6(f6.3,f6.4))                                             eag25990
 2000 format (//27h horizontal earthquake data /                        eag26000
     .          27h --------------------------//                        eag26010
     .108h      time  accn-g      time  accn-g      time  accn-g      tieag26020
     .me  accn-g      time  accn-g      time  accn-g //                 eag26030
     .(6(4x,f6.3,2x,f6.4)))                                             eag26040
2001  format(//27h   vertical earthquake data /                         eag26050
     .          27h --------------------------//                        eag26060
     .108h      time  accn-g      time  accn-g      time  accn-g      tieag26070
     .me  accn-g      time  accn-g      time  accn-g //                 eag26080
     .(6(4x,f6.3,2x,f6.4)))                                             eag26090
      end                                                               eag26100
      subroutine writeb (a,la,n,numel)                                  eag26110
c                                                                       eag26120
c     ******************************************************************eag26130
c     write element data on tape                                        eag26140
c     ******************************************************************eag26150
c                                                                       eag26160
      implicit real*8 (a-h,o-z)                                         eag26170
      common /buf/ b(2220)                                              eag26180
      dimension a(la)                                                   eag26190
c                                                                       eag26200
      lb=2220                                                           eag26210
      if (n.ne.1) go to 100                                             eag26220
      m=0                                                               eag26230
      rewind 1                                                          eag26240
  100 mm=m+la                                                           eag26250
      do 200 i=1,la                                                     eag26260
      ii=i+m                                                            eag26270
  200 b(ii)=a(i)                                                        eag26280
      m=mm                                                              eag26290
      if ( n .eq. numel ) go to 300                                     eag26300
      if ( (m+la) .le. lb ) go to 400                                   eag26310
  300 write (1) b                                                       eag26320
      m=0                                                               eag26330
  400 return                                                            eag26340
      end                                                               eag26350
      subroutine writey(y,ln,itape)                                     eag26360
c                                                                       eag26370
c     ******************************************************************eag26380
c     write response data on tape                                       eag26390
c     ******************************************************************eag26400
c                                                                       eag26410
      implicit real*8 (a-h,o-z)                                         eag26420
      dimension y(ln)                                                   eag26430
c                                                                       eag26440
      write (itape) y                                                   eag26450
      return                                                            eag26460
      end                                                               eag26470
      subroutine fft (r,m,l,k,it,tw)                                    eag26480
c                                                                       eag26490
c     ******************************************************************eag26500
c     compute forward and inverse fast fourier transform (fft)          eag26510
c     ******************************************************************eag26520
c                                                                       eag26530
      implicit real*8 (a-h,o-z)                                         eag26540
      dimension r(1)                                                    eag26550
      integer y,yf,z,z2,z3,z4                                           eag26560
c                                                                       eag26570
      je=16                                                             eag26580
      ji=je*2                                                           eag26590
      nk=2**(m-k)*l                                                     eag26600
      if(nk.lt.4) stop                                                  eag26610
      s2=.7071067811865475244d0                                         eag26620
      s3=1.7320508075688772935d0/(2-it)                                 eag26630
      pi=3.14159265358979323846d0                                       eag26640
      if(it.eq.1) go to 2                                               eag26650
      if(l.eq.2) call sort2(r,nk,tw)                                    eag26660
      if(l.eq.3) call sort3(r,m,0,tw)                                   eag26670
         call lpstor(l-1,r,0,nk,0,0,s3)                                 eag26680
    2 if(m.eq.1) go to 4                                                eag26690
      m1=m-1                                                            eag26700
      do 100 i=1,m1                                                     eag26710
      if(it.eq.0) inc=2**i*l                                            eag26720
      if(it.eq.1) inc=2**(m-i)*l                                        eag26730
      i2=inc-2                                                          eag26740
      incd=inc*2                                                        eag26750
         if(k.ge.i) call lpstor(3,r,0,i2,incd,inc,0.)                   eag26760
      if(k.ge.i) go to 100                                              eag26770
      pid=pi/incd                                                       eag26780
      c=dcos(2.*pid)                                                    eag26790
      s=dsin(2.*pid)                                                    eag26800
         call lpstor(4+it,r,0,nk,incd,inc,0.)                           eag26810
      if(inc.eq.4) go to 19                                             eag26820
      jf=inc/2-1                                                        eag26830
         do 10 j=3,jf,ji                                                eag26840
         ang=(j-3)*pid                                                  eag26850
         cc=dcos(ang)                                                   eag26860
         ss=dsin(ang)                                                   eag26870
         yf=min0(j+ji-2,jf)                                             eag26880
         do 10 y=j,yf,2                                                 eag26890
         z3=-i2-y                                                       eag26900
         ct=cc                                                          eag26910
         cc=ct*c-ss*s                                                   eag26920
         ss=ss*c+s*ct                                                   eag26930
         if(it.eq.1) go to 13                                           eag26940
         do 12 z=y,nk,incd                                              eag26950
         z2=z+1                                                         eag26960
         z3=z3+incd                                                     eag26970
         z4=z3+1                                                        eag26980
         r1=r(z+inc)*cc+r(z2+inc)*ss                                    eag26990
         r2=r(z2+inc)*cc-r(z+inc)*ss                                    eag27000
         r3=r(z3+inc)*ss+r(z4+inc)*cc                                   eag27010
         r4=r(z4+inc)*ss-r(z3+inc)*cc                                   eag27020
         r(z+inc)=r(z3)-r3                                              eag27030
         r(z2+inc)=-r(z4)+r4                                            eag27040
         r(z3+inc)=r(z)-r1                                              eag27050
         r(z4+inc)=-r(z2)+r2                                            eag27060
         r(z)=r(z)+r1                                                   eag27070
         r(z2)=r(z2)+r2                                                 eag27080
         r(z3)=r(z3)+r3                                                 eag27090
   12    r(z4)=r(z4)+r4                                                 eag27100
         go to 10                                                       eag27110
   13    do 14 z=y,nk,incd                                              eag27120
         z2=z+1                                                         eag27130
         z3=z3+incd                                                     eag27140
         z4=z3+1                                                        eag27150
         r1=r(z)-r(z3+inc)                                              eag27160
         r2=r(z2)+r(z4+inc)                                             eag27170
         r3=r(z3)-r(z+inc)                                              eag27180
         r4=r(z4)+r(z2+inc)                                             eag27190
         r(z)=r(z)+r(z3+inc)                                            eag27200
         r(z2)=r(z2)-r(z4+inc)                                          eag27210
         r(z3)=r(z3)+r(z+inc)                                           eag27220
         r(z4)=r(z4)-r(z2+inc)                                          eag27230
         r(z+inc)=r1*cc-r2*ss                                           eag27240
         r(z2+inc)=r2*cc+r1*ss                                          eag27250
         r(z3+inc)=r3*ss-r4*cc                                          eag27260
   14    r(z4+inc)=r4*ss+r3*cc                                          eag27270
   10    continue                                                       eag27280
      if(inc.eq.6) go to 100                                            eag27290
   19 ls=inc/2+1                                                        eag27300
         call lpstor(6+it,r,ls,nk,incd,inc,s2)                          eag27310
  100 continue                                                          eag27320
    4 if(it.eq.0) return                                                eag27330
         call lpstor(6+l,r,0,nk,0,0,s3)                                 eag27340
      if(l.eq.2) call sort2(r,nk,tw)                                    eag27350
      if(l.eq.3) call sort3(r,m-k,1,tw)                                 eag27360
      return                                                            eag27370
      end                                                               eag27380
      subroutine lpstor (ns,r,ls,lf,incd,inc,cc)                        eag27390
c                                                                       eag27400
c     ******************************************************************eag27410
c     stores do loops required by subroutine fft                        eag27420
c     ******************************************************************eag27430
c                                                                       eag27440
      implicit real*8 (a-h,o-z)                                         eag27450
      dimension r(1)                                                    eag27460
c                                                                       eag27470
      go to (1,2,3,4,5,6,7,8,9), ns                                     eag27480
    1    do 11 l=1,lf,4                                                 eag27490
         r1=r(l)+r(l+1)                                                 eag27500
         r2=r(l+2)+r(l+3)                                               eag27510
         r(l+3)=-r(l+2)+r(l+3)                                          eag27520
         r(l+2)=r(l)-r(l+1)                                             eag27530
         r(l)=r1+r2                                                     eag27540
   11    r(l+1)=r1-r2                                                   eag27550
      return                                                            eag27560
    2    do 12 l=1,lf,6                                                 eag27570
         r1=r(l)+r(l+3)                                                 eag27580
         r2=r(l)-r(l+3)                                                 eag27590
         r3=r(l+1)+r(l+2)                                               eag27600
         r4=r(l+1)-r(l+2)                                               eag27610
         r5=r(l+4)+r(l+5)                                               eag27620
         r6=r(l+4)-r(l+5)                                               eag27630
         r(l)=r1+r3+r5                                                  eag27640
         r(l+1)=r2+r4+r6                                                eag27650
         r(l+2)=r2-(r4+r6)*.5                                           eag27660
         r(l+3)=(-r3+r5)*cc                                             eag27670
         r(l+4)=r1-(r3+r5)*.5                                           eag27680
   12    r(l+5)=(r4-r6)*cc                                              eag27690
      return                                                            eag27700
    3 r(1)=r(1)+r(2)                                                    eag27710
      r(2)=r(inc+1)+r(inc+1)                                            eag27720
         do 13 l=1,lf,2                                                 eag27730
         r(l+2)=r(l+2)+r(incd-l)                                        eag27740
   13    r(l+3)=r(l+3)-r(incd-l+1)                                      eag27750
      return                                                            eag27760
    4    do 14 l=1,lf,incd                                              eag27770
         l1=l+inc                                                       eag27780
         r3=r(l1)                                                       eag27790
         r(l1)=r(l+1)                                                   eag27800
         r(l1+1)=-r(l1+1)                                               eag27810
         r(l+1)=r(l)-r3                                                 eag27820
   14    r(l)=r(l)+r3                                                   eag27830
      return                                                            eag27840
    5    do 15 l=1,lf,incd                                              eag27850
         l1=l+inc                                                       eag27860
         r3=r(l1)                                                       eag27870
         r(l1)=r(l)-r(l+1)                                              eag27880
         r(l1+1)=-r(l1+1)-r(l1+1)                                       eag27890
         r(l)=r(l)+r(l+1)                                               eag27900
   15    r(l+1)=r3+r3                                                   eag27910
      return                                                            eag27920
    6    do 16 l=ls,lf,incd                                             eag27930
         l2=l+1                                                         eag27940
         r1=(r(l+inc)+r(l2+inc))*cc                                     eag27950
         r2=(r(l2+inc)-r(l+inc))*cc                                     eag27960
         r(l+inc)=r(l)-r1                                               eag27970
         r(l2+inc)=-r(l2)+r2                                            eag27980
         r(l)=r(l)+r1                                                   eag27990
   16    r(l2)=r(l2)+r2                                                 eag28000
      return                                                            eag28010
    7    do 17 l=ls,lf,incd                                             eag28020
         l2=l+1                                                         eag28030
         r1=r(l)-r(l+inc)                                               eag28040
         r2=r(l2)+r(l2+inc)                                             eag28050
         r(l)=r(l)+r(l+inc)                                             eag28060
         r(l2)=r(l2)-r(l2+inc)                                          eag28070
         r(l+inc)=(r1-r2)*cc                                            eag28080
   17    r(l2+inc)=(r1+r2)*cc                                           eag28090
      return                                                            eag28100
    8    do 18 l=1,lf,4                                                 eag28110
         r1=r(l)+r(l+1)                                                 eag28120
         r2=r(l)-r(l+1)                                                 eag28130
         r3=r(l+2)+r(l+2)                                               eag28140
         r4=r(l+3)+r(l+3)                                               eag28150
         r(l)=r1+r3                                                     eag28160
         r(l+1)=r1-r3                                                   eag28170
         r(l+2)=r2-r4                                                   eag28180
   18    r(l+3)=r2+r4                                                   eag28190
      return                                                            eag28200
    9    do 19 l=1,lf,6                                                 eag28210
         r1=r(l)+r(l+1)                                                 eag28220
         r2=r(l)-r(l+1)                                                 eag28230
         r3=r(l+2)+r(l+4)                                               eag28240
         r4=r(l+2)-r(l+4)                                               eag28250
         r5=(r(l+3)+r(l+5))*cc                                          eag28260
         r6=(r(l+3)-r(l+5))*cc                                          eag28270
         r(l)=r1+r3+r3                                                  eag28280
         r(l+1)=r1-r3-r6                                                eag28290
         r(l+4)=r1-r3+r6                                                eag28300
         r(l+2)=r2+r4-r5                                                eag28310
         r(l+3)=r2-r4-r4                                                eag28320
   19    r(l+5)=r2+r4+r5                                                eag28330
      return                                                            eag28340
      end                                                               eag28350
      subroutine sort2 (r,nk,tw)                                        eag28360
c                                                                       eag28370
c     ******************************************************************eag28380
c     shuffles or unshuffles the nk real terms of r and multiplies by tweag28390
c     ******************************************************************eag28400
c                                                                       eag28410
      implicit real*8 (a-h,o-z)                                         eag28420
      dimension r(1),nvec(8)                                            eag28430
      data nvec/4,2,6,1,5,3,7,0/                                        eag28440
c                                                                       eag28450
      nf=1                                                              eag28460
      nk2=nk/2                                                          eag28470
      nk8=nk/8                                                          eag28480
      if(nk.lt.32) nk8=nk-1                                             eag28490
         do 10 i=1,nk8                                                  eag28500
         ic=0                                                           eag28510
         nt=nf                                                          eag28520
         do 12 j=i,nk,nk8                                               eag28530
         if(nt.le.j) go to 2                                            eag28540
         stor=r(nt)                                                     eag28550
         r(nt)=r(j)                                                     eag28560
         r(j)=stor                                                      eag28570
         ic=ic+1                                                        eag28580
   12    nt=nf+nvec(ic)                                                 eag28590
    2    nsub=nk2                                                       eag28600
    4    if(nsub.ge.nf) go to 10                                        eag28610
         nf=nf-nsub                                                     eag28620
         nsub=nsub/2                                                    eag28630
         go to 4                                                        eag28640
   10    nf=nf+nsub                                                     eag28650
         do 20 i=1,nk                                                   eag28660
   20    r(i)=r(i)*tw                                                   eag28670
      return                                                            eag28680
      end                                                               eag28690
      subroutine sort3 (r,mk,isrt,tw)                                   eag28700
c                                                                       eag28710
c     ******************************************************************eag28720
c     shuffles (isrt=0) or unshuffles (isrt=1) the  nk=(2**mk)*3 real   eag28730
c     terms of r.  subroutine sort2 is called.                          eag28740
c     ******************************************************************eag28750
c                                                                       eag28760
      implicit real*8 (a-h,o-z)                                         eag28770
      dimension r(1)                                                    eag28780
c                                                                       eag28790
      nk=2**mk*3                                                        eag28800
      nl=1+2*nk/3                                                       eag28810
      if(isrt.eq.0) call sort2(r,2*nk/3,tw)                             eag28820
      if(isrt.eq.0) call sort2(r(nl),nk/3,tw)                           eag28830
         do 10 i=1,mk                                                   eag28840
         l=i                                                            eag28850
         if(isrt.eq.0) l=mk-i+1                                         eag28860
         if(l.eq.1) go to 10                                            eag28870
         i2=2**(l-1)                                                    eag28880
         i21=i2-1                                                       eag28890
         js=2*i2+1                                                      eag28900
         ji=6*i2                                                        eag28910
         if(isrt.eq.0) i2=i2*2                                          eag28920
         i3=ji/2-i2                                                     eag28930
         do 12 j=js,nk,ji                                               eag28940
         kf=j+i21                                                       eag28950
         do 12 k=j,kf                                                   eag28960
         rst=r(k)                                                       eag28970
         r(k)=r(k+i2)                                                   eag28980
         r(k+i2)=r(k+i3)                                                eag28990
   12    r(k+i3)=rst                                                    eag29000
   10    continue                                                       eag29010
      if(isrt.eq.1) call sort2(r,2*nk/3,tw)                             eag29020
      if(isrt.eq.1) call sort2(r(nl),nk/3,tw)                           eag29030
      return                                                            eag29040
      end                                                               eag29050
